var frmDeviceMgmt_m_initialize = false;
var frmDeviceMgmt_m_xmlResponse = null;

var frmDeviceMgmt_m_CurrentDevice = null;
var frmDeviceMgmt_m_CurrentAccountID = "";
var frmDeviceMgmt_m_CurrentStateID = "";
var frmDeviceMgmt_m_CurrentMapID = "";
var frmDeviceMgmt_m_SortBy = "name";
var frmDeviceMgmt_m_SortType = "ASC";

var frmDeviceMgmt_m_CurrentPage = 1;
var frmDeviceMgmt_m_FirstPage = 1;
var frmDeviceMgmt_m_TotalPage = 1;

var frmDeviceMgmt_m_KVMIP = "";
var frmDeviceMgmt_m_KVMPort = "";
var frmDeviceMgmt_m_KVMPassword = "";
var frmDeviceMgmt_m_KVMMode = 1;
var frmDeviceMgmt_m_KVMRepeaterIP = "";
var frmDeviceMgmt_m_KVMRepeaterID = "1234";
var frmVNCView_isCustMode = false;
var frmVNCView_deviceStatus;
var frmVNCView_osVersion;
var frmVNCView_deviceName;
var frmDeviceMgmt_m_AgentID = "";
var frmDeviceMgmt_m_SelectAccountID = "";
var frmDeviceMgmt_m_MapItemDroped = null;   //remember the item drop to Map tree;
var frmDeviceMgmt_m_SelectAgentID = "";
var frmDeviceMgmt_m_ExpandAgentID = [];
var frmDeviceMgmt_m_Draging = false;
var frmDeviceMgmt_m_MapRatio = 100;
var frmDeviceMgmt_m_OTAHandlerExist = false;
var frmDeviceMgmt_m_DeviceInfo;

//added by ken 20140912
var frmDeviceMgmt_log = log4jq.getLogger({
    loggerName: 'frmDeviceMgmt'
});

$(document).ready(function () {
    frmDeviceMgmt_log.info('page ready');
    frmDeviceMgmt_ModeFunction();
    frmDeviceMgmt_TabFunction();
    frmDeviceMgmt_TableFunction();
    frmDeviceMgmt_PageOperation();
    frmDeviceMgmt_MapFunction();
    frmDeviceMgmt_SortOperation();
});

function frmDeviceMgmt_initialize()
{
    frmDeviceMgmt_log.info('call frmDeviceMgmt_initialize func');
    if (!frmDeviceMgmt_m_initialize)
    {
        window.lang.run();
        window.lang.change($.cookie('selectedLang'));
        frmDeviceMgmt_m_initialize = true;
    }

    //search tooltip for MUI
    $('#frmDeviceMgmt_FuzzySearchSpan .ui-input-clear').attr('title', $('#index_clearSearchText').html());
    //Tab
    $("#frmDeviceMgmt_TabSelect a").attr("isFocus", "false");
    if ($.cookie('selectedDeviceMgmtTabPage') == null)
        $.cookie('selectedDeviceMgmtTabPage', "All", {
            expires: myCookieExpiresDate
        });
    switch ($.cookie('selectedDeviceMgmtTabPage'))
    {
        case 'All':
            $('#frmDeviceMgmt_Tab_AllDevice').attr("isFocus", "true");
            frmDeviceMgmt_m_CurrentAccountID = "";
            frmDeviceMgmt_m_CurrentStateID = "";
            break;
        case 'My':
            $('#frmDeviceMgmt_Tab_MyDevice').attr("isFocus", "true");
            frmDeviceMgmt_m_CurrentAccountID = m_aid;
            frmDeviceMgmt_m_CurrentStateID = "";
            break;
        case 'Failed':
            $('#frmDeviceMgmt_Tab_FailedDevice').attr("isFocus", "true");
            frmDeviceMgmt_m_CurrentAccountID = "";
            frmDeviceMgmt_m_CurrentStateID = "2";
            break;
    }
    //Mode
    frmDeviceMgmt_ModeDisplay();
    frmDeviceMgmt_m_ExpandAgentID = [];
    frmDeviceMgmt_m_MapRatio = 100;
    //index_EditButtonStatus();
}

function frmDeviceMgmt_ModeFunction()
{
    frmDeviceMgmt_log.info('call frmDeviceMgmt_ModeFunction func');

    var $frmDeviceMgmt_ActionBar = $("#frmDeviceMgmt_ActionBar");

    $('#frmDeviceMgmt_Mode_Map').click(function () {

        frmDeviceMgmt_log.debug('change map mode: Map');
        $$.LoadingMsg(true);
        $.cookie('frmDeviceMgmt_ViewMode', "Map");
        frmDeviceMgmt_ModeDisplay();

        //added by ken 20140924
        $frmDeviceMgmt_ActionBar.hide();
    });

    $('#frmDeviceMgmt_Mode_Group').click(function () {
        frmDeviceMgmt_log.debug('change map mode: Group');
        $$.LoadingMsg(true);
        $.cookie('frmDeviceMgmt_ViewMode', "Group");
        frmDeviceMgmt_ModeDisplay();

        //added by ken 20140924
        $frmDeviceMgmt_ActionBar.hide();
    });

    $('#frmDeviceMgmt_Mode_List').click(function () {
        frmDeviceMgmt_log.debug('change map mode: List');
        $$.LoadingMsg(true);
        $.cookie('frmDeviceMgmt_ViewMode', "List");
        frmDeviceMgmt_ModeDisplay();

        //added by ken 20140924
        $frmDeviceMgmt_ActionBar.show();
    });
}

function frmDeviceMgmt_ModeDisplay()
{
    if ($.cookie('frmDeviceMgmt_ViewMode') == null)
        $.cookie('frmDeviceMgmt_ViewMode', "List", {
            expires: myCookieExpiresDate
        });
    switch ($.cookie('frmDeviceMgmt_ViewMode'))
    {
        case 'Map':
            $('#frmDeviceMgmt_TabSelect').hide();
            $('#frmDeviceMgmt_Mode_Map').removeClass('mode-button').addClass('mode-button-active');
            $('#frmDeviceMgmt_Mode_Group').removeClass('mode-button-active').addClass('mode-button');
            $('#frmDeviceMgmt_Mode_List').removeClass('mode-button-active').addClass('mode-button');
            $('#index_pnlDeviceMap').show();
            $('#index_pnlDeviceGroup').hide();
            $('#frmDeviceMgmt_Tab_DeviceMap').show();
            $('#frmDeviceMgmt_Tab_DeviceList').hide();
            $('#frmDeviceMgmt_Print').hide();
            $('#frmDeviceMgmt_FuzzySearchSpan').hide();
            index_LoadMapPanel();
            break;
        case 'Group':
            $('#frmDeviceMgmt_TabSelect').hide();
            $('#frmDeviceMgmt_Mode_Map').removeClass('mode-button-active').addClass('mode-button');
            $('#frmDeviceMgmt_Mode_Group').removeClass('mode-button').addClass('mode-button-active');
            $('#frmDeviceMgmt_Mode_List').removeClass('mode-button-active').addClass('mode-button');
            $('#index_pnlDeviceMap').hide();
            $('#index_pnlDeviceGroup').show();
            $('#frmDeviceMgmt_Tab_DeviceMap').hide();
            $('#frmDeviceMgmt_Tab_DeviceList').show();
            $('#frmDeviceMgmt_DeviceHeaderDiv').hide();
            $('#frmDeviceMgmt_DeviceBodyDiv').hide();
            $('#frmDeviceMgmt_GroupHeaderDiv').show();
            $('#frmDeviceMgmt_GroupBodyDiv').show();
            $('#frmDeviceMgmt_Print').hide();
            $('#frmDeviceMgmt_FuzzySearchSpan').show();
            index_LoadGroupPanel();
            break;
        case 'List':
            $('#frmDeviceMgmt_TabSelect').show();
            $('#frmDeviceMgmt_Mode_Map').removeClass('mode-button-active').addClass('mode-button');
            $('#frmDeviceMgmt_Mode_Group').removeClass('mode-button-active').addClass('mode-button');
            $('#frmDeviceMgmt_Mode_List').removeClass('mode-button').addClass('mode-button-active');
            $('#index_pnlDeviceMap').hide();
            $('#index_pnlDeviceGroup').show();
            $('#frmDeviceMgmt_Tab_DeviceMap').hide();
            $('#frmDeviceMgmt_Tab_DeviceList').show();
            $('#frmDeviceMgmt_DeviceHeaderDiv').show();
            $('#frmDeviceMgmt_DeviceBodyDiv').show();
            $('#frmDeviceMgmt_GroupHeaderDiv').hide();
            $('#frmDeviceMgmt_GroupBodyDiv').hide();
            $('#frmDeviceMgmt_Print').show();//comment by ken 20140918
            $('#frmDeviceMgmt_FuzzySearchSpan').show();
            index_LoadGroupPanel();
            break;
    }
}

function frmDeviceMgmt_TabFunction()
{
    frmDeviceMgmt_log.info('call frmDeviceMgmt_TabFunction func');
    frmDeviceMgmt_log.info('tab event-binding');

    $('#frmDeviceMgmt_Tab_MyDevice, #frmDeviceMgmt_Tab_AllDevice, #frmDeviceMgmt_Tab_FailedDevice').click(function () {

        frmDeviceMgmt_log.debug('current tab type: ' + $(this).attr("id"));

        $("#frmDeviceMgmt_TabSelect a").attr("isFocus", "false");
        $(this).attr("isFocus", "true");
        $("#frmDeviceMgmt_TabSelect a").removeClass('TabSelectFocus');
        $(this).addClass('TabSelectFocus');

        switch ($(this).attr("id"))
        {
            case 'frmDeviceMgmt_Tab_AllDevice':
                $$.LoadingMsg(true);
                $.cookie('selectedDeviceMgmtTabPage', "All");
                frmDeviceMgmt_m_CurrentMapID = frmDeviceMgmt_m_CurrentMapID;
                frmDeviceMgmt_m_CurrentAccountID = "";
                frmDeviceMgmt_m_CurrentStateID = "";
                frmDeviceMgmt_m_CurrentPage = 1;
                frmDeviceMgmt_DeviceFuzzySearch();
                break;
            case 'frmDeviceMgmt_Tab_MyDevice':
                $$.LoadingMsg(true);
                $.cookie('selectedDeviceMgmtTabPage', "My");
                frmDeviceMgmt_m_CurrentMapID = frmDeviceMgmt_m_CurrentMapID;
                frmDeviceMgmt_m_CurrentAccountID = m_aid;
                frmDeviceMgmt_m_CurrentStateID = "";
                frmDeviceMgmt_m_CurrentPage = 1;
                frmDeviceMgmt_DeviceFuzzySearch();
                break;
            case 'frmDeviceMgmt_Tab_FailedDevice':
                $$.LoadingMsg(true);
                $.cookie('selectedDeviceMgmtTabPage', "Failed");
                frmDeviceMgmt_m_CurrentMapID = frmDeviceMgmt_m_CurrentMapID;
                frmDeviceMgmt_m_CurrentAccountID = "";
                frmDeviceMgmt_m_CurrentStateID = "2";
                frmDeviceMgmt_m_CurrentPage = 1;
                frmDeviceMgmt_DeviceFuzzySearch();
                break;
        }
    });

    //Print
    $('#frmDeviceMgmt_Print').click(function () {
        if (typeof frmDeviceListPrintFilter_initialize == 'undefined')
        {
            $('#index_pnlDevicePrint').load('frmDeviceListPrintFilter.html?d=' + escape(Date()), function () {
                $('#index_pnlDevicePrint').trigger('create');
                $global.faddingShow(true);
                frmDeviceListPrintFilter_initialize();
                $('#index_pnlDevicePrint').fadeIn();
            })
        }
        else
        {
            $global.faddingShow(true);
            frmDeviceListPrintFilter_initialize();
            $('#index_pnlDevicePrint').fadeIn();
        }
    });

}

function frmDeviceDelDevice_CallBack(returnStr)
{
    switch (returnStr)
    {
        case frmMsgDialog_ReturnMsg.OK:
            frmDeviceDelete_Delete();
            break;
        case frmMsgDialog_ReturnMsg.Cancel:
            break;
    }
}

function frmDeviceDelete_Delete()
{
    $$.LoadingMsg(true);
    var xml = "<request></request>";
    var xmlDoc = $.parseXML(xml);
    var nodeParent = $.parseXML('<device/>');

    var nodeItem;
    nodeItem = $.parseXML('<item name="accountid" value="1"></item>');
    $(nodeParent).children(0).append($(nodeItem).children(0));
    nodeItem = $.parseXML('<item name="groupid" value="1"></item>');
    $(nodeParent).children(0).append($(nodeItem).children(0));
    nodeItem = $.parseXML('<item name="mapid" value="1"></item>');
    $(nodeParent).children(0).append($(nodeItem).children(0));

    $(xmlDoc).children(0).append($(nodeParent).children(0));
    $global.Submit("/DeviceMgmt/" + frmDeviceMgmt_m_SelectAgentID, "put", $$.xmlToString(xmlDoc), m_user, m_password, frmDeviceDelete_DeleteCallback);
}

function frmDeviceDelete_DeleteCallback(xmlResponse)
{
    var oXML = $.parseXML($$.xmlToString(xmlResponse));
    if ($(oXML).find('result').contents().empty().end().text() == "true")
    {
        //        $('#index_pnlDeviceDelete').hide();
        index_ClearFocusArray();
        $global.faddingShow(false);
        frmDeviceGroup_LoadAccountAndGroup();
    }
    else
    {
        $$.LoadingMsg(false);
        $$.MessageBox("error", $('#frmMessage_AddFailed').html());
    }
}

function frmDeviceMgmt_TableFunction()
{
    frmDeviceMgmt_log.info('call frmDeviceMgmt_TableFunction func');
    frmDeviceMgmt_log.info('table of device mgmt event-binding');

    //added by ken 20140916

    var $selectAllCheckBox = $('#selectALL');
    var $frmDeviceMgmt_DeviceHeader = $('#frmDeviceMgmt_DeviceHeader'); // header of device mgmt
    var $frmDeviceMgmt_DeviceBody = $('#frmDeviceMgmt_DeviceBody');//body of device mgmt
    var $frmDeviceMgmt_ColumnVisibleMenu = $('#frmDeviceMgmt_ColumnVisibleMenu');


    //added by ken 20140919
    //dispaly column visble menu
//    $frmDeviceMgmt_DeviceHeader.find('tr th').on("contextmenu",function(e){
//    $frmDeviceMgmt_DeviceHeader.find('tr').on("contextmenu", function (e) {
//        frmDeviceMgmt_log.debug('open column show/hide menu');
//
//        var $currTh = e.currentTarget;
//        $frmDeviceMgmt_ColumnVisibleMenu.show().popup();//dispaly and init with popup func
//        $frmDeviceMgmt_ColumnVisibleMenu.popup('open', {
//            positionTo: $currTh
//        });
//    });


    //added by ken 20140919
    //column visble menu click event
    $frmDeviceMgmt_ColumnVisibleMenu.find('ul li a').on("click", function (e) {
        var newIcon = null;

        var $currVisbleItem = $(this);
        var oldIcon = $currVisbleItem.attr('data-icon');
        var checkOrNot = (oldIcon == 'check') ? true : false;
        var visibleOrNot = !checkOrNot;
        frmDeviceMgmt_setColumnVisableOfMenu($currVisbleItem, visibleOrNot);
    });

    //select all checkbox
    $selectAllCheckBox.click(function () {
        var $cbSelectAll = $(this);
        var isChecked = $cbSelectAll.attr("checked");
        frmDeviceMgmt_log.debug('click select all:' + isChecked);

        if (typeof (isChecked) == 'undefined') {
            frmDeviceMgmt_log.debug("unselect ALL");
            //unselect
            $frmDeviceMgmt_DeviceBody.find('input:checkbox').each(function () {
                $(this).prop('checked', false).checkboxradio('refresh');
            });
        } else {
            frmDeviceMgmt_log.debug("select ALL");
            //select all
            $frmDeviceMgmt_DeviceBody.find('input:checkbox').each(function () {
                $(this).prop('checked', true).checkboxradio('refresh');
            });
        }
    });


    //added by ken 20140917
    //action bar DIV
    var $frmDeviceMgmt_ActionBar_Div = $('#frmDeviceMgmt_ActionBar_Div');
    var $frmDeviceMgmt_MoreMenu = $('#frmDeviceMgmt_MoreMenu');

    //action bar event-binding
    $frmDeviceMgmt_ActionBar_Div.find('li a').click(function () {

        var $currBtn = $(this);
        var currentActionType = $currBtn.attr('data-action');
        frmDeviceMgmt_log.debug("click action bar: " + currentActionType);

        switch (currentActionType)
        {
            case 'adddev':
                frmDeviceGroup_AddDevice();
                break;
            case 'deldev':
                //get current devices and delete
                var $checkboxs = $('#frmDeviceMgmt_DeviceBody').find("input:checkbox:checked");
                var countOfSelectedDevices = $checkboxs.length;
                frmDeviceMgmt_log.debug('count of selected device: ' + countOfSelectedDevices);
                if (countOfSelectedDevices > 1) {

                    frmDeviceMgmt_log.debug('multi-devices delete');

                    //show message dialog
                    //                    $$.MessageDialog(
                    //                    frmMsgDialog_MsgType.normal, 
                    //                    , 
                    //                    frmMsgDialog_BtnType.OKCancel, 
                    //                    function(){
                    //                         frmDeviceMgmt_log.debug('close dialog of multi-devices');
                    //                         
                    //                    });

                } else if (countOfSelectedDevices == 1) {

                    frmDeviceMgmt_log.debug('one device delete');
                    //tirgger original grpDelete button (grpDelete is hide for new layout)
                    //you can refer to frmDeviceMap.js
                    frmDeviceMgmt_m_CurrentDevice.find('.deleteRow').click();


                } else {
                    //no device
                    frmDeviceMgmt_log.warn('Plz select device');
                }
                break;
            case 'more':
                //dispaly more menu
                $frmDeviceMgmt_MoreMenu.show().popup();//dispaly and init with popup func
                $frmDeviceMgmt_MoreMenu.popup("open", {
                    positionTo: $currBtn
                });
                break;
        }
    });

    //added by ken 20140918
    //more menu action event-binding
    $frmDeviceMgmt_MoreMenu.find('li a').click(function () {
        var $currBtn = $(this);
        var currentActionType = $currBtn.attr('data-action');
        frmDeviceMgmt_log.debug("click more action: " + currentActionType);

        //close more menu
        $frmDeviceMgmt_MoreMenu.popup('close');

        switch (currentActionType)
        {
            //remove ctroller
            case 'kvm':

                break;
            case 'console':

                break;
            case 'screenshot':

                break;
                //Maintaintance
            case 'none':

                break;
            case 'to_be_maintanined':

                break;
            case 'maintaining':

                break;
            case 'finish':

                break;
                //power
            case 'poweroff':

                break;
            case 'restart':

                break;
                //backup and recovery
            case 'backup':

                break;
            case 'recovery':

                break;
                //device status
            case 'hwstatus':

                break;
            case 'swstatus':

                break;
            case 'sensorstatus':

                break;
                //other
            case 'print':
                //trigger print button
                $("#frmDeviceMgmt_Print").click();
                break;
        }
    });

    //open wsn network
    //added by ken 20141023
    $frmDeviceMgmt_DeviceBody.on('click', 'tr td span.dev-cell-type-wsn', function (event) {
        try
        {
            event.stopPropagation();
        }
        catch(e){}
        frmDeviceMgmt_log.debug('click wsn network');

        if (typeof frmDeviceMgmtWSNTopology_initialize == 'undefined')
        {
            $('#index_pnlDeviceMgmtWSNTopology').load('frmDeviceMgmtWSNTopology.html?d=' + escape(Date()), function () {
                $('#index_pnlDeviceMgmtWSNTopology').trigger('create');
                $global.faddingShow(true);
                setTimeout(function () {
                    frmDeviceMgmtWSNTopology_initialize();
                    $('#index_pnlDeviceMgmtWSNTopology').fadeIn(function () {
                        frmDeviceMgmtWSNTopology_DrawNetworkFunction();
                    });
                }, 100)
            });
        }
        else
        {
            $global.faddingShow(true);
            setTimeout(function () {
                frmDeviceMgmtWSNTopology_initialize();
                $('#index_pnlDeviceMgmtWSNTopology').fadeIn(function () {
                    frmDeviceMgmtWSNTopology_DrawNetworkFunction();
                });
            }, 100)
        }

    });
    //expand sensor
    //added by ken 20140922

    $frmDeviceMgmt_DeviceBody.on('click', 'tr td span.dev-cell-name-expand-sensor', function (event) {
        try
        {
            event.stopPropagation();
        }
        catch(e){}
        frmDeviceMgmt_log.info('click expand sensor');
        //added by ken 2015/03/05
        //hide column menu時有把這些列hide，因為要在展開
//        $('#frmDeviceMgmt_DeviceBody tr[class="hide-device"]').show();
        var $currTR = $(this).parent().parent().parent().parent();
        var $nexHideTR = $currTR.next();
        if ($nexHideTR.hasClass('hide-device')) {
            $nexHideTR.show();
        }

        var $currExpand = $(this);
        var $parentTD = $currExpand.parent().parent().parent();
        //        frmDeviceMgmt_log.debug('find td');
        var $parentTR = $parentTD.parent();
        var $tdUnderParentTR = $parentTR.find('td:visible');
        //        frmDeviceMgmt_log.debug('find next tr');
        var $nextTR = $parentTR.next();
        var $tdUnderTR = $nextTR.find('> td');
        var valOfColspan = $tdUnderParentTR.length;
        frmDeviceMgmt_log.debug('find td for colspan:' + valOfColspan);
        $tdUnderTR.attr('colspan', valOfColspan);

        var $sensorTable = $nextTR.find('table');

        var $iconElem = $currExpand.find('img');
        var oldIcon = 'plus.png';

        var $parentTr = $sensorTable.find('tr[class*=treegridparent]');
        frmDeviceMgmt_log.debug('find count: ' + $parentTr.length);
        var sensorType = $sensorTable.attr('data-type');

        if ($parentTr.length > 0) {
            $.each($parentTr, function (i, obj) {
                var $tr = $(this);
                var pathId = $tr.attr('data-sensor-id');
                frmDeviceMgmt_log.debug('delete path id: ' + pathId);
                $sensorTable.removeData(pathId);
            });

            //reset tr
            $sensorTable.find('tbody').find('tr').remove();
        }

        if ($iconElem.attr('src').indexOf(oldIcon) >= 0) {
            
            var nItem = $.inArray($currTR.attr("ItemValue"), frmDeviceMgmt_m_ExpandAgentID);
            if (nItem == -1)
                frmDeviceMgmt_m_ExpandAgentID.push($currTR.attr("ItemValue"));
            newIcon = 'minus.png';
            frmDeviceMgmt_log.debug('show sensor list');
            //            $parentTD.find(".sensorMenu").show();
            //            {"thd":"max-min","min":0,"u":"Cel","max":100,"type":"temp","bn":"01","n":"temperature"}
            $$.LoadingMsg(true);

            $nextTR.find('td').show('fast');

            var sensorType = $sensorTable.attr('data-type');
            var handler = 'IoTGW';
            frmDeviceMgmt_log.debug('sensor table type: ' + sensorType);

            var dataDeviceId = $parentTR.attr('data-device-id');
            var deviceData = $frmDeviceMgmt_DeviceBody.data(dataDeviceId);
            var $senNodes = $(deviceData).find('IoTGW sensorHub');
            if ($senNodes.length > 0) {
                frmDeviceMgmt_log.debug('start to create sennode tree');
                frmDeviceMgmt_buildSenNodeTreegirdElem($sensorTable, $senNodes);
                $$.LoadingMsg(false);
            } else {
                frmDeviceMgmt_log.error('SenNode not found');
                $$.MessageBox('error', $('#frmDeviceMgmt_szSenNodeDialogNotFound').html());
                $$.LoadingMsg(false);
            }



            $parentTR.find('td').addClass('dev-cell-name-unborder');
            //remove border bottom, let arrow is beautiful,20141027


        } else {
            var nItem = $.inArray($currTR.attr("ItemValue"), frmDeviceMgmt_m_ExpandAgentID);
            if (nItem > -1)
                frmDeviceMgmt_m_ExpandAgentID.splice(nItem, 1);
            newIcon = "plus.png";
            frmDeviceMgmt_log.debug('hide sensor list');
            //            $parentTD.find(".sensorMenu").hide();

            $nextTR.find('td').hide('fast');
            $parentTR.find('td').removeClass('dev-cell-name-unborder');
        }

        $iconElem.attr('src', 'images/' + newIcon);

        //reset for IE
        frmDeviceMgmt_resetTableColumnOnIE8();
    });

//    $('#frmDeviceMgmt_FuzzySearch').live('keydown', function () {
//        if (event.shiftKey)
//        {
//            if ((event.keyCode == 51) || (event.keyCode == 53) || (event.keyCode == 55) || (event.keyCode == 188) || (event.keyCode == 222))
//            {
//                event.preventDefault(); 
//                return false;
//            }
//        }
//    });

    //fuzzySearch
    $('#frmDeviceMgmt_FuzzySearch').live('keyup', function () {
        clearTimeout($(this).attr("fuzzySrearchTimeID"));
        var tid = setTimeout(function () {
            $$.LoadingMsg(true);
            frmDeviceMgmt_m_CurrentPage = 1;
            frmDeviceMgmt_DeviceFuzzySearch();
        }, m_fuzzySearchTimeBuffer);
        $(this).attr("fuzzySrearchTimeID", tid);
    });
    $('#frmDeviceMgmt_FuzzySearchSpan .ui-input-clear').live('click', function () {
        $$.LoadingMsg(true);
        frmDeviceMgmt_m_CurrentPage = 1;
        frmDeviceMgmt_DeviceFuzzySearch();
    });

    //TR Click
    $("#frmDeviceMgmt_DeviceBody tr").die('click').live("click", function () {
        frmDeviceMgmt_log.debug('click row of device mgmt: record selected data');
        frmDeviceMgmt_m_CurrentDevice = $(this);
        frmDeviceMgmt_m_SelectAgentID = $(this).attr("ItemValue");
    });

    //Delete Device
    $("#frmDeviceMgmt_DeviceBody tr .deleteRow").die('click').live("click", function () {
        $$.MessageDialog(frmMsgDialog_MsgType.normal, $('#frmDeviceMgmt_DelDeviceMsg').html(), frmMsgDialog_BtnType.OKCancel, frmDeviceDelDevice_CallBack);
        //        if(typeof frmDeviceDelete_initialize == 'undefined')
        //        {
        //            $('#index_pnlDeviceDelete').load('frmDeviceDelete.html?d=' + escape(Date()),function(){
        //                $('#index_pnlDeviceDelete').trigger('create');
        //                $global.faddingShow(true);
        //                frmDeviceDelete_initialize();
        //                $('#index_pnlDeviceDelete').show();
        //            })
        //        }
        //        else
        //        {
        //            $global.faddingShow(true);
        //            frmDeviceDelete_initialize();
        //            $('#index_pnlDeviceDelete').show();
        //        }
    });

    //Upgrade
    $(".devUpgrade").die('click').live("click", function (e) {
        var strItemType = $(this).parent().parent().parent().attr("ItemType");
        if (strItemType == "device")
        {
            frmDeviceMgmt_DeviceUpgrade($(this).parent().parent().parent().attr("ItemValue"));
        }
        if (strItemType == "group")
        {
            var strGroupId = $(this).parent().parent().parent().attr("ItemValue");
            var strGroupName = $(this).parent().parent().parent().attr("GroupName");
            var strQty = $(this).parent().parent().parent().attr("UpgradeDev") + " / " + $(this).parent().parent().parent().attr("TotalDev");
            var strUpgradeVersion = $(this).parent().parent().parent().attr("LatestVersion");
            var strLock = $(this).parent().parent().parent().attr("Lock");
            frmDeviceMgmt_GroupUpgrade(strGroupId, strGroupName, strQty, strUpgradeVersion, strLock);
        }
    });

    //Remote control
    $(".devRemote").die('click').live("click", function (e) {
        // check device support OTAHandler
        var devRemoteClick =$(this);
        
        $(frmDeviceMgmt_m_DeviceInfo).find("agentId").each(function () {
            if ($(this).text() == $(devRemoteClick).parent().parent().parent().attr("ItemValue")){
                frmDeviceMgmt_m_OTAHandlerExist = false;
                $(this).siblings("handlerList").find("handlerName").each(function () {
                    if ($(this).text() == "OTAHandler")
                        frmDeviceMgmt_m_OTAHandlerExist = true
                });
            } 
            
        });
        $global.Submit("/SettingMgmt/ota", "get", "", m_user, m_password, frmDeviceOTAPackage_PkgExistCallback); 
        
        $('#index_DevicePopupInfo').attr("ItemValue", $(this).parent().parent().parent().attr("ItemValue"));
        $('#index_DevicePopupInfo').attr("ItemName", $(this).parent().parent().parent().attr("ItemName"));
        $('#index_DevicePopupInfo').attr("DeviceStatus", $(this).parent().parent().parent().attr('DeviceStatus'));
        $('#index_DevicePopupInfo').attr("AmtSupport", $(this).parent().parent().parent().attr('AmtSupport'));
        $('#index_DevicePopupInfo').attr("DeviceIP", $(this).parent().parent().parent().attr('DeviceIP'));
        $('#index_DevicePopupInfo').attr("KVMmode", $(this).parent().parent().parent().attr('KVMmode'));
        $('#index_DevicePopupInfo').attr("custPort", $(this).parent().parent().parent().attr('custPort'));
        $('#index_DevicePopupInfo').attr("custPassword", $(this).parent().parent().parent().attr('custPassword'));
        $('#index_DevicePopupInfo').attr("osversion", $(this).parent().parent().parent().attr('osversion'));
        var terminalFun = $(this).parent().parent().parent().attr('terminalFun');
        var kvmFun = $(this).parent().parent().parent().attr('kvmFun');
        var screenshotFun = $(this).parent().parent().parent().attr('screenshotFun');
        var bKVM = false;
        var bAMTKVM = false;
        var bTerminal = false;
        var bSS = false;
        if ($.inArray("e", privilege_array) > -1)   //KVM, Terminal, ScreenShot
        {
            if ($('#index_DevicePopupInfo').attr("AmtSupport") == "true")
            {
                if ($('#index_DevicePopupInfo').attr("KVMmode") != 'disable')
                {
                    if (index_isSeparateKVMAMT)
                    {
                        bAMTKVM = true;
                        if ($('#index_DevicePopupInfo').attr("DeviceStatus").toLowerCase() == 'connected'){
                            if(kvmFun !== '' && kvmFun.toLowerCase().indexOf('disable') < 0){
                                bKVM = true;
                            }                            
                        }                            
                    }
                    else{
                        if(kvmFun !== '' && kvmFun.toLowerCase().indexOf('disable') < 0){
                            bKVM = true;
                        }                        
                    }                        
                }
            }
            else
            {
                if ($('#index_DevicePopupInfo').attr("DeviceStatus").toLowerCase() == 'connected')
                {
                    if ($('#index_DevicePopupInfo').attr("KVMmode") != 'disable'){
                        if(kvmFun !== '' && kvmFun.toLowerCase().indexOf('disable') < 0){
                            bKVM = true;
                        }                        
                    }                        
                }
            }

            if ($('#index_DevicePopupInfo').attr("DeviceStatus").toLowerCase() == 'connected')
            {
                if(terminalFun !== '' && terminalFun.toLowerCase().indexOf('internal') >= 0){
                    bTerminal = true;
                }                
            }

            if ($('#index_DevicePopupInfo').attr("DeviceStatus").toLowerCase() == 'connected')
            {
                if(screenshotFun !== '' && screenshotFun.toLowerCase().indexOf('internal') >= 0){
                    bSS = true;
                }                
            }
        }

        if (!bKVM && !bTerminal && !bSS && !bAMTKVM)
            return;

        $('#index_lstDevicePopupInfo li').each(function () {
            $(this).removeClass('ui-corner-bottom ui-li-last ui-corner-top');
            $(this).show();
        });

        //        if(index_isSeparateKVMAMT)
        //        {
        //            if($('#index_DevicePopupInfo').attr("AmtSupport") == 'true')
        //                $('#index_DevicePopupInfo .iAMTKVM').show();
        //            else
        //                $('#index_DevicePopupInfo .iAMTKVM').hide();
        //        }
        //        else
        //            $('#index_DevicePopupInfo .iAMTKVM').hide();   

        var count = 0;

        $('#index_lstDevicePopupInfo li').each(function () {
            if (frmDeviceMgmt_issupportNoVNC()) {
                if (!bKVM && $(this).attr('ItemValue') === 'DeviceNoVNC')
                    $(this).hide();
                if (!bAMTKVM && $(this).attr('ItemValue') === 'DeviceiAMTNoVNC')
                    $(this).hide();
                if ($(this).attr('ItemValue') === 'DeviceKVM') {
                    $(this).hide();
                }
                if ($(this).attr('ItemValue') === 'DeviceiAMTKVM') {
                    $(this).hide();
                }
            } else {
                if (!bKVM && $(this).attr('ItemValue') === 'DeviceKVM')
                    $(this).hide();
                if (!bAMTKVM && $(this).attr('ItemValue') === 'DeviceiAMTKVM')
                    $(this).hide();
                if ($(this).attr('ItemValue') === 'DeviceNoVNC') {
                    $(this).hide();
                }
                if ($(this).attr('ItemValue') === 'DeviceiAMTNoVNC') {
                    $(this).hide();
                }
            }
            if (!bTerminal && $(this).attr('ItemValue') === 'DeviceTerminal')
                $(this).hide();
            if (!bSS && $(this).attr('ItemValue') === 'ScreenShot')
                $(this).hide();
            if ($(this).css('display') === 'block')
                count++;
        });

        if (count == 1)
        {
            $('#index_lstDevicePopupInfo li').each(function () {
                if ($(this).css('display') == 'block')
                {
                    $(this).addClass('ui-corner-top ui-corner-bottom ui-li-last');
                }
            })
        }
        else
        {
            var index = count - 1;
            var ishastop = false;
            $('#index_lstDevicePopupInfo li').each(function () {
                if (index == 0)
                {
                    $(this).addClass('ui-corner-bottom ui-li-last');
                    return;
                }
                if ($(this).css('display') == 'block')
                {
                    if (!ishastop)
                    {
                        $(this).addClass('ui-corner-top');
                        ishastop = true;
                    }
                    index = index - 1;
                }
            })
        }
        setTimeout(function () {
            $('#index_DevicePopupInfo').show();   
            $('#index_DevicePopupInfo').popup("open", {
                x: devRemoteClick.offset().left + 100,
                y: devRemoteClick.offset().top
            });
        },500);
    });

    //KVM
    $(".devKVM").die('click').live("click", function (e) {
        if ($(this).parent().parent().parent().attr('DeviceStatus') == "Connected")
        {
            frmDeviceMgmt_KVMInfo($(this).parent().parent().parent().attr("ItemValue"));
        }
    });

    //Terminal
    $(".devTerminal").die('click').live("click", function (e) {
        if ($(this).parent().parent().parent().attr('DeviceStatus') == "Connected")
        {
            frmDeviceMgmt_openTerminal($(this).parent().parent().parent().attr("ItemValue"));
        }
    });

    //MaintainState
    $("#frmDeviceMgmt_MaintainState").die('click').live("click", function (e) {
        //e.stopPropagation();
    });
    $("#frmDeviceMgmt_MaintainState").die('change').live("change", function (e) {
        $(this).parent().parent().parent().parent().find('.ViewMode').attr("SelectedText", $("option:selected", this).text());
        frmDeviceMgmt_m_CurrentDevice = $(this).parent().parent().parent().parent().parent();
        frmDeviceMgmt_EditMaintainState($(this).val());
    });

    //modifeid by ken 20140925 
    //Device Info / Edit
    //    $("#frmDeviceMgmt_DeviceBody tr td:nth-child(2) span a").die('click').live("click", function(e) {
    $frmDeviceMgmt_DeviceBody.find('tr td.dev-cell-name a').die('click').live("click", function (e) {
        //e.stopPropagation();
        var agentId = $(this).parent().parent().parent().attr('ItemValue');
        frmDeviceMgmt_log.debug("open device info dialog: " + agentId);

        //comment by ken 2015/03/04
        //        if ($(this).parent().parent().parent().attr('ItemType').toLowerCase() != "device") return;

        frmDeviceMgmt_DeviceBasicEdit(agentId, true);
    });

    $("#frmDeviceMgmt_GroupBody tr td:nth-child(1) span a , #frmDeviceMgmt_GroupBody tr td:nth-child(2) span a , #frmDeviceMgmt_GroupBody tr td:nth-child(3) span a").die('click').live("click", function (e) {
        frmDeviceMgmt_log.debug("change model of device mgmt: group list to device list");
        frmDeviceGroup_m_CurrentGroupNode.Panel = "Group";
        frmDeviceGroup_m_CurrentGroupNode.Direction = "right";
        frmDeviceGroup_m_CurrentGroupNode.ItemType = "Group";
        frmDeviceGroup_m_CurrentGroupNode.GroupID = $(this).parent().parent().parent().attr("ItemValue");
        $.cookie('selectedGroup31', JSON.stringify(frmDeviceGroup_m_CurrentGroupNode), {expires: myCookieExpiresDate});
        frmDeviceGroup_m_CurrentGroup = $('#' + "frmDeviceGroup_Group_" + frmDeviceGroup_m_CurrentGroupNode.GroupID);
        $('#frmDeviceGroup_ulGroup li').find('a').removeClass("lstTreeFocus");
        frmDeviceGroup_m_CurrentGroup.find('a').addClass('lstTreeFocus');
        $('#frmDeviceMgmt_Mode_List').click();
    });

    //Device Hardware Information
    $("#frmDeviceMgmt_DeviceBody .hwInfo").die('click').live("click", function (e) {
        frmDeviceMgmt_log.debug("click hw status");

        var $parentTR = $(this).parent().parent().parent();
        var strType = $parentTR.attr("ItemType");
        var strID = $parentTR.attr("ItemValue");
        //        var strName = $parentTR.find("td").eq(1).find("a").html();
        var strName = $parentTR.attr("ItemName");
        var strConnected = $parentTR.attr("DeviceStatus");

        frmDeviceMgmt_log.debug("show hardware info dialog");
        frmDeviceMgmt_DeviceHWInfo(strType, strID, strName, strConnected, $(this).attr("DefaultTab"));

    });

    //Device HardwareSetting
    $("#frmDeviceMgmt_DeviceBody .hwSetting").die('click').live("click", function (e) {
        frmDeviceMgmt_log.debug("open hardware monitor setting dialog");
        e.stopPropagation();

        var strType = $(this).parent().parent().parent().attr("ItemType");
        var strID = $(this).parent().parent().parent().attr("ItemValue");
        var strName = $(this).parent().parent().parent().attr("ItemName");
        var strConnected = $(this).parent().parent().parent().attr("DeviceStatus");

        if (typeof frmDeviceMgmtHardwareSetting_initialize == 'undefined')
        {
            $('#index_pnlDeviceMgmtHardwareSetting').load('frmDeviceMgmtHardwareSetting.html?d=' + escape(Date()), function () {
                $('#index_pnlDeviceMgmtHardwareSetting').trigger('create');
                $global.faddingShow(true);
                frmDeviceMgmtHardwareSetting_initialize(strType, strID, strName, strConnected);
            });
        }
        else
        {
            $global.faddingShow(true);
            frmDeviceMgmtHardwareSetting_initialize(strType, strID, strName, strConnected);
        }
    });

    //Group HardwareSetting
    $("#frmDeviceMgmt_GroupBody .hwSetting").die('click').live("click", function (e) {

        frmDeviceMgmt_log.debug("open hardware monitor setting dialog");
        e.stopPropagation();

        var strType = $(this).parent().parent().parent().attr("ItemType");
        var strID = $(this).parent().parent().parent().attr("ItemValue");
        var strName = $(this).parent().parent().parent().find("td").eq(0).find("a").html();
        var strConnected = $(this).parent().parent().parent().attr("DeviceStatus");
        if (typeof frmDeviceMgmtHardwareSetting_initialize == 'undefined')
        {
            $('#index_pnlDeviceMgmtHardwareSetting').load('frmDeviceMgmtHardwareSetting.html?d=' + escape(Date()), function () {
                $('#index_pnlDeviceMgmtHardwareSetting').trigger('create');
                $global.faddingShow(true);
                frmDeviceMgmtHardwareSetting_initialize(strType, strID, strName, strConnected);
            });
        }
        else
        {
            $global.faddingShow(true);
            frmDeviceMgmtHardwareSetting_initialize(strType, strID, strName, strConnected);
        }
    });

    $("#frmDeviceMgmt_DeviceBody tr td:nth-child(3) span a").die('click').live("click", function (e) {
        //update func name, comment by ken 20150123
        //        frmDeviceGroup_SetFocus($(this).parent().parent().parent().attr("AccountID") , $(this).parent().parent().parent().attr("ItemValue"));
        frmDeviceGroup_setFocus($(this).parent().parent().parent().attr("AccountID"), $(this).parent().parent().parent().attr("ItemValue"));

        //$('#frmDeviceMgmt_Mode_List').click();
        $('#frmDeviceMgmt_DeviceHeaderDiv').show();
        $('#frmDeviceMgmt_DeviceBodyDiv').show();
        $('#frmDeviceMgmt_GroupHeaderDiv').hide();
        $('#frmDeviceMgmt_GroupBodyDiv').hide();
    });

    //Device Software Information
    $("#frmDeviceMgmt_DeviceBody .swInfo").die('click').live("click", function (e) {
        frmDeviceMgmt_log.debug("open software info dialog");

        var strType = $(this).parent().parent().parent().attr("ItemType");
        var strID = $(this).parent().parent().parent().attr("ItemValue");
        var strName = $(this).parent().parent().parent().find("td").eq(1).find("a").html();
        var strConnected = $(this).parent().parent().parent().attr("DeviceStatus");

        frmDeviceMgmt_DeviceSWInfo(strType, strID, strName, strConnected);

    });

    //Device SoftwareSetting
    $("#frmDeviceMgmt_DeviceBody .swSetting").die('click').live("click", function (e) {
        frmDeviceMgmt_log.debug("open software monitor setting dialog");

        e.stopPropagation();
        var strType = $(this).parent().parent().parent().attr("ItemType");
        var strID = $(this).parent().parent().parent().attr("ItemValue");
        var strName = $(this).parent().parent().parent().attr("ItemName");
        var strConnected = $(this).parent().parent().parent().attr("DeviceStatus");
        if (typeof frmDeviceMgmtSoftwareSetting_initialize == 'undefined')
        {
            $('#index_pnlDeviceMgmtSoftwareSetting').load('frmDeviceMgmtSoftwareSetting.html?d=' + escape(Date()), function () {
                $('#index_pnlDeviceMgmtSoftwareSetting').trigger('create');
                $global.faddingShow(true);
                frmDeviceMgmtSoftwareSetting_initialize(strType, strID, strName, strConnected);
            });
        }
        else
        {
            $global.faddingShow(true);
            frmDeviceMgmtSoftwareSetting_initialize(strType, strID, strName, strConnected);
        }
    });

    //Group SoftwareSetting
    $("#frmDeviceMgmt_GroupBody .swSetting").die('click').live("click", function (e) {
        frmDeviceMgmt_log.debug("open software monitor setting dialog");

        e.stopPropagation();
        var strType = $(this).parent().parent().parent().attr("ItemType");
        var strID = $(this).parent().parent().parent().attr("ItemValue");
        var strName = $(this).parent().parent().parent().find("td").eq(0).find("a").html();
        var strConnected = $(this).parent().parent().parent().attr("DeviceStatus");
        if (typeof frmDeviceMgmtSoftwareSetting_initialize == 'undefined')
        {
            $('#index_pnlDeviceMgmtSoftwareSetting').load('frmDeviceMgmtSoftwareSetting.html?d=' + escape(Date()), function () {
                $('#index_pnlDeviceMgmtSoftwareSetting').trigger('create');
                $global.faddingShow(true);
                frmDeviceMgmtSoftwareSetting_initialize(strType, strID, strName, strConnected);
            });
        }
        else
        {
            $global.faddingShow(true);
            frmDeviceMgmtSoftwareSetting_initialize(strType, strID, strName, strConnected);
        }
    });

    //added by ken 2014/11/14
    //agent report
    $frmDeviceMgmt_DeviceBody.find('tr td.dev-cell-report a').die('click').live("click", function (e) {
        //device info
        var $parentTR = $(this).parent().parent();

        var agentType = $parentTR.attr("ItemType");
        var agentID = $parentTR.attr("ItemValue");//agent id
        var agentName = $parentTR.attr("ItemName");//agent name

        var $currStatus = $(this);

        var reportStatus = $currStatus.attr('data-report');

        frmDeviceMgmt_log.debug("click report status (Level 1): " + reportStatus);
        frmDeviceMgmt_OpenAgentReport(agentID, agentName, agentType, reportStatus, $currStatus);
    });

    //change administrator
    $("#frmDeviceMgmt_SelectAdministrator").die('click').live("click", function () {
        if ($(this).parent().attr('disabled'))
            return;
        frmDeviceMgmt_m_SelectAgentID = $(this).parent().parent().parent().attr('ItemValue');
        frmDeviceMgmt_m_SelectAccountID = $(this).parent().parent().parent().attr('AccountID');
        if (typeof frmDeviceSelectAdministrator_initialize == 'undefined')
        {
            $('#index_pnlDeviceSelectAdministrator').load('frmDeviceSelectAdministrator.html?d=' + escape(Date()), function () {
                $('#index_pnlDeviceSelectAdministrator').trigger('create');
                $global.faddingShow(true);
                frmDeviceSelectAdministrator_initialize();
                $('#index_pnlDeviceSelectAdministrator').show();
                frmDeviceSelectAdministrator_m_CallBack = frmDeviceMgmt_SelectAccount;
            });
        }
        else
        {
            $global.faddingShow(true);
            frmDeviceSelectAdministrator_initialize();
            $('#index_pnlDeviceSelectAdministrator').show();
            frmDeviceSelectAdministrator_m_CallBack = frmDeviceMgmt_SelectAccount;
        }
    });
}

function frmDeviceOTAPackage_PkgExistCallback(xmlResponse)
{
    if ($(xmlResponse).find("ErrorCode").length == 0)
    {
        if ($(xmlResponse).find("ota").find("enable").text() == "true" && frmDeviceMgmt_m_OTAHandlerExist) {
            // IE11, avoid revealing line on top of this row. 
            $('#OTAPackageDownload').removeClass('ui-corner-bottom');
            $('#OTAPackageDownload').show();
        } else 
            $('#OTAPackageDownload').hide();  
    }
    else
    {  
        $('#OTAPackageDownload').hide(); 
    }    
}

function frmDeviceMgmt_DeviceFuzzySearch()
{
    frmDeviceMgmt_log.info('call frmDeviceMgmt_DeviceFuzzySearch func : ' + frmDeviceMgmt_m_Draging);
    if (frmDeviceMgmt_m_Draging)
        return;

    frmDeviceMgmt_log.info('call frmDeviceMgmt_DeviceFuzzySearch func : ' + $.cookie('frmDeviceMgmt_ViewMode'));
    if ($.cookie('frmDeviceMgmt_ViewMode') == "Group")
    {
        frmDeviceMgmt_DeviceFuzzySearchGroup();
        return;
    }
    var xml = "<request></request>";
    var xmlDoc = $.parseXML(xml);

    var nodelang = $.cookie('selectedLang');
    nodelang = $.parseXML('<lang value="' + index_m_selectedLang.replace(/_/g, '-') + '"></lang>');
    $(xmlDoc).children(0).append($(nodelang).children(0));
    //clause
    var nodeClause = $.parseXML('<clause/>');
    var nodeItem;
    if (frmDeviceMgmt_m_CurrentMapID != "")
    {
        nodeItem = $.parseXML('<item name="map_id" value="' + frmDeviceMgmt_m_CurrentMapID + '"></item>');
        $(nodeClause).children(0).append($(nodeItem).children(0));
    }

    if ($('#index_BtnFlatMode').attr("flatMode") == "true")
    {
        if (typeof frmDeviceGroup_m_CurrentGroup.attr("ItemValue") != 'undefined')
            nodeItem = $.parseXML('<item name="group_id" value="' + frmDeviceGroup_m_CurrentGroup.attr("ItemValue") + '"></item>');
        else
            nodeItem = $.parseXML('<item name="group_id" value="1"></item>');
        $(nodeClause).children(0).append($(nodeItem).children(0));
    }
    else
    {
        if (typeof frmDeviceGroup_m_CurrentGroup.attr("ItemValue") != 'undefined')
        {
            nodeItem = $.parseXML('<item name="group_id" value="' + frmDeviceGroup_m_CurrentGroup.attr("ItemValue") + '"></item>');
            $(nodeClause).children(0).append($(nodeItem).children(0));
        }
    }

    if (typeof frmDeviceGroup_m_CurrentGroup.attr("AccID") != 'undefined')
    {
        nodeItem = $.parseXML('<item name="account_id" value="' + frmDeviceGroup_m_CurrentGroup.attr("AccID") + '"></item>');
        $(nodeClause).children(0).append($(nodeItem).children(0));
    }
    else
    {
        $('#frmDeviceMgmt_DeviceBody tr').has('td').remove();
        $$.LoadingMsg(false);
        return;
    }

    if (frmDeviceMgmt_m_CurrentStateID != "")
    {
        nodeItem = $.parseXML('<item name="devicestate" value="Error"></item>');
        $(nodeClause).children(0).append($(nodeItem).children(0));
    }
    $(xmlDoc).children(0).append($(nodeClause).children(0));

    //like
    var strEscape = $$.EscapeString($.trim($('#frmDeviceMgmt_FuzzySearch').val()));
    var nodeLike = $.parseXML('<like/>');
    nodeItem = $.parseXML('<item name="condition" value="' + strEscape + '"></item>');
    $(nodeLike).children(0).append($(nodeItem).children(0));
    nodeItem = $.parseXML('<item name="field" value="name"></item>');
    $(nodeLike).children(0).append($(nodeItem).children(0));
//    nodeItem = $.parseXML('<item name="field" value="hwstate"></item>');
//    $(nodeLike).children(0).append($(nodeItem).children(0));
//    nodeItem = $.parseXML('<item name="field" value="swstate"></item>');
//    $(nodeLike).children(0).append($(nodeItem).children(0));
    nodeItem = $.parseXML('<item name="field" value="maintainstate"></item>');
    $(nodeLike).children(0).append($(nodeItem).children(0));
//    nodeItem = $.parseXML('<item name="field" value="accountname"></item>');
//    $(nodeLike).children(0).append($(nodeItem).children(0));
    //added by ken 2015/05/15
//    nodeItem = $.parseXML('<item name="field" value="agent_type"></item>');
//    $(nodeLike).children(0).append($(nodeItem).children(0));
    $(xmlDoc).children(0).append($(nodeLike).children(0));

    //orderby
    var nodeOrderBy = $.parseXML('<orderby/>');
    nodeItem = $.parseXML('<item name="' + frmDeviceMgmt_m_SortBy + '" value="' + frmDeviceMgmt_m_SortType + '"></item>');
    $(nodeOrderBy).children(0).append($(nodeItem).children(0));
//    nodeItem = $.parseXML('<item name="did" value="' + frmDeviceMgmt_m_SortType + '"></item>');
//    $(nodeOrderBy).children(0).append($(nodeItem).children(0));
    $(xmlDoc).children(0).append($(nodeOrderBy).children(0));

    //resultfilter
    var nodeResult = $.parseXML('<resultfilter/>');
    nodeItem = $.parseXML('<item name="page size" value="' + m_PageSize + '"></item>');
    $(nodeResult).children(0).append($(nodeItem).children(0));
    nodeItem = $.parseXML('<item name="page no" value="' + Math.max(frmDeviceMgmt_m_CurrentPage, 1) + '"></item>');
    $(nodeResult).children(0).append($(nodeItem).children(0));
    $(xmlDoc).children(0).append($(nodeResult).children(0));
    $global.Submit("/DeviceMgmt/fuzzySearch", "post", $$.xmlToString(xmlDoc), m_user, m_password, frmDeviceMgmt_DeviceFuzzySearchCallback); 
}

function frmDeviceMgmt_DeviceFuzzySearchCallback(xmlResponse)
{
    frmDeviceMgmt_m_DeviceInfo = $(xmlResponse).find("result");
    frmDeviceMgmt_log.info('call frmDeviceMgmt_DeviceFuzzySearchCallback func');

    if ($(xmlResponse).find("ErrorCode").length != 0)
    {
        $$.MessageBox("error", $(xmlResponse).find("Description").text());
        $$.LoadingMsg(false);
        return;
    }
    var $frmDeviceMgmt_DeviceBody = $('#frmDeviceMgmt_DeviceBody');

    //    alert($$.xmlToString(xmlResponse));
    if (frmDeviceMgmt_m_Draging)
        return;
    $('#frmDeviceMgmt_GroupHeaderDiv').hide();
    $('#frmDeviceMgmt_GroupBodyDiv').hide();
    $('#frmDeviceMgmt_DeviceHeaderDiv').show();
    $('#frmDeviceMgmt_DeviceBodyDiv').show();

    frmDeviceMgmt_m_xmlResponse = xmlResponse;
    frmDeviceMgmt_m_CurrentDevice = null;
    var strBrowser = navigator.detectBrowser.toString().split(',')[0];
    var strBrowserVer = navigator.detectBrowser.toString().split(',')[1];

    frmDeviceMgmt_log.info('start to create table of device mgmt for device view');

    //added by ken 2015/5/15
//    frmDeviceMgmt_ResetColumnVisableMenu();

    //added by ken 20140916
    var countOfItems = 0;

    var i18nDeviceNormal = $('#frmMessage_DeviceNormal').html();
    var i18DeviceAbnormal = $('#frmMessage_DeviceAbNormal').html();

    var i18nDeviceMaintenNormal = $('#frmDeviceMgmt_msgDeviceMaintenNormal').html();
    var i18nDeviceMaintenToBeMaintained = $('#frmDeviceMgmt_msgDeviceMaintenToBeMaintained').html()
    var i18nDeviceMaintenMaintaining = $('#frmDeviceMgmt_msgDeviceMaintenMaintaining').html();
    var i18nDeviceMaintenFinished = $('#frmDeviceMgmt_msgDeviceMaintenFinished').html();

    var i18nDeviceRemoteControl = $('#frmDeviceMgmt_txtDeviceRemoteControl').html();

    var i18nDeviceReportEnable = $('#frmDeviceMgmt_txtDeviceReportEnable').html();
    var i18nDeviceReportDisable = $('#frmDeviceMgmt_txtDeviceReportDisable').html();

    //clear by 'frmDeviceMgmt_ClearTable'
    $('#frmDeviceMgmt_DeviceBody tr').has('td').remove();

    var total_size = parseInt($(xmlResponse).find("totalsize").text());
    if (total_size == 0)
        frmDeviceMgmt_setIconStatus(false);
    else
        frmDeviceMgmt_setIconStatus(true);

    $(xmlResponse).find("item").each(function (i, obj) {
        //      return ;//use mock data
        var $device = $(this);
        //0 meas level 1 devcie
        var deviceType = $($(this).find("agentType")[0]).text();

        //        if(deviceType == ''){
        //            deviceType = $(this).find("agentType").text();
        //        }
        //        var deviceType = $(this).find("agent_type").text();
        frmDeviceMgmt_log.debug('agent type: ' + deviceType);

        //store current device info
        $frmDeviceMgmt_DeviceBody.data(countOfItems.toString(), obj);


        //Column1
        //itemtype不要亂改(很多地方用到)
        var deviceName = $($(this).find("name")[0]).text();

        var sTR = '<tr data-device-id="' + countOfItems +
                '"  ItemType="device" custPassword="' + $(this).find('custPassword').text()
                + '" custPort="' + $(this).find('custPort').text()
                + '" KVMmode="' + $(this).find('KVMmode').text()
                + '" DeviceIP="' + $(this).find('ip').text()
                + '" AccountID="' + $(this).find("accountid").text()
                + '" ItemValue="' + $($(this).find("agentId")[0]).text()
                + '" DeviceType="' + deviceType
                + '" ItemName="' + deviceName
                + '" osversion="' + $(this).find('osversion').text()
                + '" DeviceStatus="' + $($(this).find("status")[0]).text()
                + '" groupid="' + $(this).find("groupid").text()
                + '" mapid="' + $(this).find("mapid").text()
                + '" terminalFun="' + $(this).children("terminalFunction").text()
                + '" kvmFun="' + $(this).children("kvmFunction").text()
                + '" screenshotFun="' + $(this).children("screenShotFunction").text()
                + '" AmtSupport="' + $(this).find("amtsupport").text() + '">';

        //it will be hided by code 
        sTR = sTR + '<td class="dev-cell del-cell-del"><img class="deleteRow action-img1" src="images/delete.png"/></td>';

        //added by ken 20140916
        //row checkbox (先不出)
        //        sTR = sTR + '<td class="dev-cell dev-cell-checkbox"><label><input type="checkbox" /></label></td>';

        //Name
        var strDevstateIcon = "m/images/ico_monitor_grey.png";
        var strIoTGwstateIcon = 'images/icons/gateway-off.png';
        var strSensorNodestateIcon = 'images/icons/icons-sensor-node-off.png';

        if (deviceType === SA3.device.SenNode || deviceType === SA3.device.IPC_SenNode) {
            strDevstateIcon = strSensorNodestateIcon;
        } else if (deviceType === SA3.device.IoTGW || deviceType === SA3.device.IPC_IoTGW) {
            strDevstateIcon = strIoTGwstateIcon;
        }
        //if (($(this).find("status").text() == "Connected") && ($(this).find("hwstate").text() == "HW_Status_Normal") && ($(this).find("swstate").text() == "SW_Status_Normal")) 
        if ($($(this).find("status")[0]).text() === "Connected")
        {
            if (deviceType === SA3.device.SenNode || deviceType === SA3.device.IPC_SenNode) {
                strDevstateIcon = 'images/icons/icons-sensor-node-on.png';
            } else if (deviceType === SA3.device.IPC) {
                //device Power ON
                strDevstateIcon = "m/images/ico_monitor_green.png";
            } else if (deviceType === SA3.device.IoTGW || deviceType === SA3.device.IPC_IoTGW) {
                strDevstateIcon = 'images/icons/gateway-on.png';
            }
        }

        var expandSensorHtml = '';
        var expandSensorIcon = '';
        var sensorStatus = '<span>None</span>';
        //        if(deviceType != 'IPC'){
        frmDeviceMgmt_log.debug('deviceType: ' + deviceType);
        //sensor list    
        expandSensorHtml = '<div data-role="popup"><ul id="sensorMenu_' + countOfItems + '" data-role="listview"  data-inset="true" >';
        expandSensorHtml = expandSensorHtml + '<li><a data-wrapperels="div" data-icon="arrow-r" data-iconpos="right" data-theme="c">Temprature</a></li>';
        expandSensorHtml = expandSensorHtml + '<li><a data-wrapperels="div" data-icon="arrow-r" data-iconpos="right" data-theme="c">Pressure</a></li>';
        expandSensorHtml = expandSensorHtml + '</ul>';

        if (deviceType !== SA3.device.IPC) {
            expandSensorIcon =
                    '<span class="dev-cell-name-expand-sensor" data-menu-id="' + countOfItems + '"><img src="images/plus.png" /></span>';
        }


        sensorStatus = '<a class="action-a" style="color: #000; opacity: 1 !important;">Normal</a>';
        //        }



        sTR = sTR + '<td class="dev-cell dev-cell-name">';
        if (($($(this).find("status")[0]).text() === "Connected") && ($($(this).find("upgrade")[0]).text() === "true"))
        //if (($($(this).find("status")[0]).text() === "Connected") && ($($(this).find("upgrade")[0]).text() === "true") && false)
        {
            strDevstateIcon = "images/ico_update_40.png";
            sTR = sTR + '<span class="dev-cell-name-icon-btn"><img class="devUpgrade" src="' + strDevstateIcon + '"></span>';
        }
        else {
            sTR = sTR + '<span class="dev-cell-name-icon-btn"><img src="' + strDevstateIcon + '" style="cursor: default;"></span>';
        }

        //        sTR = sTR + expandSensorIcon;

        if (($.inArray("e", privilege_array) > -1) || ($.inArray("q", privilege_array) > -1)) {
            //remote controll (KVM , Terminal ,Console)
            //modified by ken 20150303
            if (deviceType != SA3.device.SenNode && deviceType != SA3.device.IPC_SenNode) {
//                sTR = sTR + '<span style=" float: right;"><img src="images/icon_RemoteControl.png" class="devRemote action-img1" style="width: 24px; height: 24px; vertical-align:middle; align: right;" title="' + i18nDeviceRemoteControl + '"></span>';
                sTR = sTR + '<span class="dev-cell-name-icon-btn"><img src="images/icon_RemoteControl.png" class="devRemote action-img1" title="' + i18nDeviceRemoteControl + '"></span>';
            }

            //device name link
            //            sTR = sTR + '<span style="float: left; margin-top: 5px; margin-left: 10px; width: 60%; text-overflow: ellipsis !important; overflow: hidden !important;">';
            sTR = sTR + '<span class="dev-cell-name-icon-btn dev-cell-name-title">';
            //            sTR = sTR + '<a class="action-a" title="' + $(this).find("name").text() + '">' + expandSensorIcon + $(this).find("name").text() + '</a></span>';
            sTR = sTR + '<a class="action-a" title="' + deviceName + '">' + expandSensorIcon + deviceName + '</a></span>';
        }
        else {

            //device name link
            sTR = sTR + '<span class="dev-cell-name-icon-btn dev-cell-name-title">';
            //            sTR = sTR + '<a class="action-a" title="' + $(this).find("name").text() + '">' + expandSensorIcon + $(this).find("name").text() + '</a></span>';
            sTR = sTR + '<a class="action-a" title="' + deviceName + '">' + expandSensorIcon + deviceName + '</a></span>';
        }

        sTR = sTR + '</td>';//end of Name Field

        //added by ken 20140916
        //[New Colmun] Device type 
        //change to connection type
        var deviceTypeLbl = null;
        var wsnNetworkIcon = ' <span class="dev-cell-type-wsn"></span>';
        deviceTypeLbl = '<span class="dev-cell-type-title">' + deviceType + wsnNetworkIcon + '</span>';
        //modified by ken 2015/08/24 stop to display agent 
//        sTR = sTR + '<td class="dev-cell dev-cell-type">' + deviceTypeLbl + '</td>';

        //Hardware Status
        var strCursor = " cursor: pointer;";
        if (deviceType === SA3.device.SenNode || deviceType === SA3.device.IPC_SenNode)
            strCursor = "";
        var strHardwareStatus = "";
        if ($(this).children("status").text() === "Connected")
        {
            if ($(this).children("hwState").text() === "Normal")
                strHardwareStatus = '<img class="hwInfo" DefaultTab="frmDeviceMgmtHWInfo_TabH_HardwareStatus" src="images/ico_HardWare.png" style="width: 16px; height: 16px;' + strCursor + '" title="' + $('#frmDeviceMgmt_szHWStatus').html() + " : " + $('#frmDeviceMgmt_szNormal').html() + '"/>';
            else
                strHardwareStatus = '<img class="hwInfo" DefaultTab="frmDeviceMgmtHWInfo_TabH_HardwareStatus" src="images/ico_HardWareE.png" style="width: 16px; height: 16px;' + strCursor + '" title="' + $('#frmDeviceMgmt_szHWStatus').html() + " : " + $('#frmDeviceMgmt_szError').html() + '"/>';
        }
        else
            strHardwareStatus = '<img DefaultTab="frmDeviceMgmtHWInfo_TabH_HardwareStatus" src="images/ico_HardWareG.png" style="width: 16px; height: 16px; cursor: default;"/>';
        if ($(this).children("status").text() === "Connected")
        {
            if ($(this).children("netState").text() === "Normal")
                strHardwareStatus = strHardwareStatus + "&nbsp;" + '<img class="hwInfo" DefaultTab="frmDeviceMgmtHWInfo_TabH_NetworkStatus" src="images/ico_Network.png" style="width: 20px; height: 20px;' + strCursor + '" title="' + $('#frmDeviceMgmt_szNetworkStatus').html() + " : " + $('#frmDeviceMgmt_szNormal').html() + '"/>';
            else
                strHardwareStatus = strHardwareStatus + "&nbsp;" + '<img class="hwInfo" DefaultTab="frmDeviceMgmtHWInfo_TabH_NetworkStatus" src="images/ico_NetworkE.png" style="width: 20px; height: 20px;' + strCursor + '" title="' + $('#frmDeviceMgmt_szNetworkStatus').html() + " : " + $('#frmDeviceMgmt_szError').html() + '"/>';
        }
        else
            strHardwareStatus = strHardwareStatus + "&nbsp;" + '<img DefaultTab="frmDeviceMgmtHWInfo_TabH_NetworkStatus" src="images/ico_NetworkG.png" style="width: 20px; height: 20px; cursor: default;"/>';
        if ($(this).children("status").text() === "Connected")
        {
            if ($(this).children("hddState").text() === "Normal")
                strHardwareStatus = strHardwareStatus + "&nbsp;" + '<img class="hwInfo" DefaultTab="frmDeviceMgmtHWInfo_TabH_HDDStatus" src="images/ico_HDD.png" style="width: 20px; height: 20px;' + strCursor + '" title="' + $('#frmDeviceMgmt_szHDDStatus').html() + " : " + $('#frmDeviceMgmt_szNormal').html() + '"/>';
            else
                strHardwareStatus = strHardwareStatus + "&nbsp;" + '<img class="hwInfo" DefaultTab="frmDeviceMgmtHWInfo_TabH_HDDStatus" src="images/ico_HDDE.png" style="width: 20px; height: 20px;' + strCursor + '" title="' + $('#frmDeviceMgmt_szHDDStatus').html() + " : " + $('#frmDeviceMgmt_szError').html() + '"/>';
        }
        else
            strHardwareStatus = strHardwareStatus + "&nbsp;" + '<img DefaultTab="frmDeviceMgmtHWInfo_TabH_HDDStatus" src="images/ico_HDDG.png" style="width: 20px; height: 20px; cursor: default;"/>';

        //added by ken 2015/03/09 SenNode不支援此功能
        if (deviceType === SA3.device.SenNode) {
            strHardwareStatus = i18nDeviceNormal;
        }
        strHardwareStatus = '<span style="float: left; margin-left: 10px; width: 80%; text-overflow: ellipsis !important; overflow: hidden !important;">' + strHardwareStatus + '</span>';
        strHardwareStatus = strHardwareStatus + '<span style="float: right;"><img src="images/settings.png" class="hwSetting action-img1" style="width: 16px; height: 16px; vertical-align:middle; align: right;" title="' + $('#frmDeviceMgmt_txtDeviceHWRule').html() + '"></span></td>';
        sTR = sTR + '<td class="dev-cell dev-cell-hw">' + strHardwareStatus + '</td>';

        //Software Status
        var strSoftwareStatus = "";
        if ($(this).children("status").text() === "Connected")
        {
            if ($(this).children("swState").text() === "Normal")
                strSoftwareStatus = '<img class="swInfo" src="images/ico_Software.png" style="width: 20px; height: 20px;' + strCursor + '" title="' + $('#frmDeviceMgmt_szSWStatus').html() + ": " + $('#frmDeviceMgmt_szNormal').html() + '"/>';
            else
                strSoftwareStatus = '<img class="swInfo" src="images/ico_SoftwareE.png" style="width: 20px; height: 20px;' + strCursor + '" title="' + $('#frmDeviceMgmt_szSWStatus').html() + ": " + $('#frmDeviceMgmt_szError').html() + '"/>';
        }
        else
            strSoftwareStatus = '<img src="images/ico_SoftwareG.png" style="width: 20px; height: 20px; cursor: default;"/>';

        //added by ken 2015/03/09 SenNode不支援此功能
        if (deviceType === SA3.device.SenNode) {

            strSoftwareStatus = i18nDeviceNormal;
        }

        strSoftwareStatus = '<span style="float: left; margin-left: 10px; width: 80%; text-overflow: ellipsis !important; overflow: hidden !important;">' + strSoftwareStatus + '</span>';
        strSoftwareStatus = strSoftwareStatus + '<span style="float: right;"><img src="images/settings.png" class="swSetting action-img1" style="width: 16px; height: 16px; vertical-align:middle;" title="' + $('#frmDeviceMgmt_txtDeviceSWRule').html() + '"></span></td>';
        sTR = sTR + '<td class="dev-cell dev-cell-sw">' + strSoftwareStatus + '</td>';

        //added by ken 20140916
        //[New Colmun] Sensor status
        var reportStatus = "false";
        var oReport = null;
        try
        {
            oReport = $.parseJSON($(this).children("autoReport").text());
        }
        catch (e) {
        }
        if (oReport != null)
//            if (oReport.hasOwnProperty('e'))
//                reportStatus = (oReport.e.length > 0)? "true":"false";
//            if (oReport.hasOwnProperty('All'))
//                reportStatus =  "false";
//            else
            reportStatus = "true";
        if (reportStatus === 'true') {
            if ($.inArray("a", privilege_array) > -1) {
                reportStatus = '<a class="action-a" style="color:  #000; opacity: 1 !important;" title="' + i18nDeviceReportEnable + '" data-report="enable"><img src="images/autoreport_on.png" style="width: 20px; height: 20px;"/></a>';
            } else {
                reportStatus = '<a class="action-a ui-disabled" style="color:  #000; opacity: 1 !important;" title="' + i18nDeviceReportEnable + '" data-report="enable"><img src="images/autoreport_on.png" style="width: 20px; height: 20px;" class="action-img2 ui-disabled" disabled="disabled"/></a>';
            }
        } else {
            if ($.inArray("a", privilege_array) > -1) {
                reportStatus = '<a class="action-a" style="color: red; opacity: 1 !important;" title="' + i18nDeviceReportDisable + '"  data-report="disable"><img src="images/autoreport_off.png" style="width: 20px; height: 20px;"/></a>';
            } else {
                reportStatus = '<a class="action-a ui-disabled" style="color: red; opacity: 1 !important;" title="' + i18nDeviceReportDisable + '"  data-report="disable"><img src="images/autoreport_off.png" style="width: 20px; height: 20px;"/></a>';
            }

        }

        sTR = sTR + '<td class="dev-cell dev-cell-report">' + reportStatus + '</td>';


        //MaintainState
        /*
        var strMainState = $(this).find("mainstate").text();
        var strMainStateText = "";
        sTR = sTR + '<td class="dev-cell dev-cell-ms" style="padding: 2px 5px 0px 5px !important;"><div class="EditMode"><select class="devMaintainState Select-black " id="frmDeviceMgmt_MaintainState" data-mini="true">';
        if (strMainState === "1")
        {
            sTR = sTR + '<option value="1" selected>' + i18nDeviceMaintenNormal + '</option>';
            strMainStateText = $('#frmDeviceMgmt_msgDeviceMaintenNormal').html();
        }
        else
            sTR = sTR + '<option value="1">' + i18nDeviceMaintenNormal + '</option>';
        if (strMainState === "2")
        {
            sTR = sTR + '<option value="2" selected>' + i18nDeviceMaintenToBeMaintained + '</option>';
            strMainStateText = i18nDeviceMaintenToBeMaintained;
        }
        else
            sTR = sTR + '<option value="2">' + i18nDeviceMaintenToBeMaintained + '</option>';
        if (strMainState === "3")
        {
            sTR = sTR + '<option value="3" selected>' + i18nDeviceMaintenMaintaining + '</option>';
            strMainStateText = i18nDeviceMaintenMaintaining;
        }
        else
            sTR = sTR + '<option value="3">' + i18nDeviceMaintenMaintaining + '</option>';
        if (strMainState === "4")
        {
            sTR = sTR + '<option value="4" selected>' + i18nDeviceMaintenFinished + '</option>';
            strMainStateText = i18nDeviceMaintenFinished;
        }
        else
            sTR = sTR + '<option value="4">' + i18nDeviceMaintenFinished + '</option>';
        sTR = sTR + '</select></div>';
        sTR = sTR + '<a class="ViewMode" style="color: #000" title="' + strMainStateText + '">' + strMainStateText + '<a>';
        sTR = sTR + '</td>';
        */
       
        //accountid
        /*
        var strAccountID = $(this).find("accountid").text();
        var strAccountName = $(this).find("accountname").text();
        if ((strBrowser.indexOf("MSIE") === 0) && (parseInt(strBrowserVer) <= 8))
            sTR = sTR + '<td class="dev-cell dev-cell-admin" align="center" style="padding: 2px 5px 0px 5px !important;"><div class="EditMode">';
        else
            sTR = sTR + '<td class="dev-cell dev-cell-admin" align="center" style="padding: 2px 5px 0px 5px !important;"><div class="EditMode">';

        sTR = sTR + '<a data-theme="c" data-role="button" data-mini="true" data-icon="search" class="adv-ui-transparent EditMode" id="frmDeviceMgmt_SelectAdministrator" accountid="' + strAccountID + '" title="' + strAccountName + '" data-role="button" data-mini="true" style="opacity: 1 !important;">' + strAccountName + '</a></div>';
        sTR = sTR + '<a class="ViewMode" style="color: #000" title="' + strAccountName + '">' + strAccountName + '<a>';
        sTR = sTR + '</td>';
        */
       
        sTR = sTR + '</tr>';
        

        // expand sensor table
        // if your change column, please update the colspan       
        //added b ken 2015/02/17
        if (deviceType === SA3.device.IoTGW || deviceType === SA3.device.IPC_IoTGW) {
            sTR = sTR + '<tr class="hide-device"><td class="hide-device-wrapper" colspan="3">';
            var sensorList = null;
            sensorList = '<table class="device-tree-table treegrid" cellspacing="0" cellpadding="0" data-type="' + deviceType + '">';
            sensorList += '<thead>';
            sensorList += '<th class="sensor-table-header-name" style="width:10%" >' + $('#frmDeviceMgmt_szSenNodeName').html() + '</th>';
            //modified by ken 2015/08/24
//            sensorList += '<th>' + $('#frmDeviceMgmt_szSenNodeAgentType').html() + '</th>';
            sensorList += '<th>' + $('#frmDeviceMgmt_szSenNodeHWStatus').html() + '</th>';
//            sensorList += '<th>' + $('#frmDeviceMgmt_szSenNodeAutoReport').html() + '</th>';
            sensorList += '<th>' + $('#frmDeviceMgmt_szSenNodeHieracchy').html() + '</th>';
//            sensorList += '<th>' + $('#frmDeviceMgmt_szSenNodeAgentId').html() + '</th>';
            sensorList += '</thead><tbody></tbody>';
            sensorList += '</table>';
        } else if (deviceType === SA3.device.SenNode || deviceType === SA3.device.IPC_SenNode) {
            sensorList = '<table class="device-tree-table" cellspacing="0" cellpadding="0" data-type="' + deviceType + '">';
            sensorList += '<thead>';
            sensorList += '<th class="sensor-table-header-name">' + $('#frmDeviceMgmt_szSensorName').html() + '</th>';
            //            sensorList += '<th>Type</th>';
            sensorList += '<th>' + $('#frmDeviceMgmt_szUnit').html() + '</th>';
            sensorList += '<th>' + $('#frmDeviceMgmt_szMin').html() + '</th>';
            sensorList += '<th>' + $('#frmDeviceMgmt_szMax').html() + '</th>';
            sensorList += '</thead><tbody></tbody>';
            sensorList += '</table>';
        } else {
            sensorList = '';//IPC no sensor list
        }
        sTR = sTR + sensorList;
        sTR = sTR + '</td></tr>';//end of sensor table


        var oTR = $(sTR);
        if ($(this).children("status").text().toLowerCase() === 'connected')
        {
            oTR.find('.devRemote').removeClass('ui-disabled');
            oTR.find('.devRemote').removeAttr('disabled', 'disabled');
        }
        else
        {
            if ($(this).children("amtsupport").text().toLowerCase() == "true")
            {
                oTR.find('.devRemote').removeClass('ui-disabled');
                oTR.find('.devRemote').removeAttr('disabled', 'disabled');
            }
            else    
            {
                oTR.find('.devRemote').addClass('ui-disabled');
                oTR.find('.devRemote').attr('disabled', 'disabled');
            }
        }

//        if (oTR.attr("DeviceType") == "IoTGW")
//        {
//            oTR.find("td").eq(3).children().addClass('ui-disabled');
//            oTR.find("td").eq(3).children().attr('disabled', 'disabled');
//            oTR.find("td").eq(4).children().addClass('ui-disabled');
//            oTR.find("td").eq(4).children().attr('disabled', 'disabled');
//            oTR.find("td").eq(5).children().addClass('ui-disabled');
//            oTR.find("td").eq(5).children().attr('disabled', 'disabled');
//        }
        //        $('#frmDeviceMgmt_DeviceBody').append(oTR);


        //performance issue
        $frmDeviceMgmt_DeviceBody.append(oTR);

        //added by ken 2015/02/17
        //set even row color =>因為多了hidden的row，所以不能直接用css控制
        var checkEvenTd = (countOfItems) % 2;
        //        frmDeviceMgmt_log.debug('current count: ' + countOfItems + ', checkEvenTd: ' + checkEvenTd + ', name: ' + $(this).find("name").text());  

        if (checkEvenTd != 0) {
            var $trOdd = $frmDeviceMgmt_DeviceBody.find('tr[data-device-id="' + countOfItems + '"]');

            if ($trOdd.length < 0) {
                frmDeviceMgmt_log.error('cannot find odd tr');
            } else {
                $trOdd.find('td').addClass('tblListEven');
            }
        }

        countOfItems++;



    });//end of for loop
//    if ($.inArray("a", privilege_array) > -1)
//    {
//        $('#frmDeviceMgmt_DeviceBody tr td.dev-cell-hw img').removeClass('ui-disabled').removeAttr('disabled', 'disabled');
//        $('#frmDeviceMgmt_DeviceBody tr td.dev-cell-sw img').removeClass('ui-disabled').removeAttr('disabled', 'disabled');
//        $('#frmDeviceMgmt_DeviceBody tr td.dev-cell-report img').removeClass('ui-disabled').removeAttr('disabled', 'disabled');
//    }
//    else
//    {
//        $('#frmDeviceMgmt_DeviceBody tr td.dev-cell-hw img').addClass('ui-disabled').attr('disabled', 'disabled');
//        $('#frmDeviceMgmt_DeviceBody tr td.dev-cell-sw img').addClass('ui-disabled').attr('disabled', 'disabled');
//        $('#frmDeviceMgmt_DeviceBody tr td.dev-cell-report img').addClass('ui-disabled').attr('disabled', 'disabled');
//    }

    //base on the privilege to disable autoreport button
    if ($.inArray("a", privilege_array) > -1)
    {
        $('#frmDeviceMgmt_DeviceBody tr td.dev-cell-report a').removeClass('ui-disabled').removeAttr('disabled', 'disabled');
        $('#frmDeviceMgmt_DeviceBody tr td.dev-cell-report a img').removeClass('ui-disabled').removeAttr('disabled', 'disabled');
    }
    else
    {
        $('#frmDeviceMgmt_DeviceBody tr td.dev-cell-report a').addClass('ui-disabled').attr('disabled', 'disabled');
        $('#frmDeviceMgmt_DeviceBody tr td.dev-cell-report a img').addClass('ui-disabled').attr('disabled', 'disabled');
    }    

    //added by ken 2015/5/15
    frmDeviceMgmt_setVisableColunmOfTable();

    //Checkbox
    //added by ken 201412/
    //    $frmDeviceMgmt_DeviceBody.find('input:checkbox').click(function(){
    //        
    //        //current selected checkbox
    //        var $currentCheckBox = $(this);
    //        
    //        var totalSelectedCb = $frmDeviceMgmt_DeviceBody.find("input:checkbox:checked").length;
    //        frmDeviceMgmt_log.debug("click checked box of row:" + totalSelectedCb);
    //          
    //        //current TR 
    //        var $parentTR = $currentCheckBox.parent().parent().parent();
    //         
    //        if(typeof($currentCheckBox.attr('checked')) != 'undefined'){
    //            frmDeviceMgmt_log.debug('select row');
    //            //seleced
    //            $parentTR.addClass('deviceSelected');
    //        }else{
    //            frmDeviceMgmt_log.debug('un-select row');
    //            //unselected
    //            $parentTR.removeClass('deviceSelected');
    //        }
    //         
    //        if(totalSelectedCb == countOfItems){
    //            $("#selectALL").prop('checked', true).checkboxradio('refresh');
    //        }else{
    //            $("#selectALL").prop('checked', false).checkboxradio('refresh');
    //        }
    //    });
    //trigger jq mobile component 
    //comment by ken 20150203
    $('#frmDeviceMgmt_DeviceBody').trigger('create');

    setTimeout(function () {
        $('#frmDeviceMgmt_DeviceBody tr').each(function ()
        {
            if ($.inArray($(this).attr("ItemValue"), frmDeviceMgmt_m_ExpandAgentID) > -1)
            {
                $(this).find(".dev-cell-name-expand-sensor").trigger('click');
            }

        });
    }, 1);
    //hide MaintainState
    //$('#frmDeviceMgmt_DeviceHeader th:nth-child(7),#frmDeviceMgmt_DeviceBody td:nth-child(7)').hide();

    //Page
    frmDeviceMgmt_m_TotalPage = Math.ceil(total_size / m_PageSize);
    frmDeviceMgmt_m_CurrentPage = Math.max(frmDeviceMgmt_m_CurrentPage, 1);
    if (frmDeviceMgmt_m_TotalPage.toString() == '0')
    {
        $('#frmDeviceMgmt_DeviceBodyDiv').hide();
        frmDeviceMgmt_m_CurrentPage = 0;
    }
    else
        $('#frmDeviceMgmt_DeviceBodyDiv').show();

    $('#frmDeviceMgmt_PageIndecator').html(frmDeviceMgmt_m_CurrentPage + " / " + frmDeviceMgmt_m_TotalPage);

    frmDeviceMgmt_setPageNumber();
    frmDeviceMgmt_SetPageCanPress();

    if ((strBrowser.indexOf("MSIE") == 0) && (parseInt(strBrowserVer) <= 9))
        $("#frmDeviceMgmt_DeviceBody td:empty").html('<span style="padding: 100%;"></span>');

    if ($('#frmDeviceMgmt_DeviceBodyDiv').hasScrollBarH())
    {
        //comment by ken 2014/11/17
        //        $('#frmDeviceMgmt_DeviceHeaderDiv').css('right', '15px');
    }
    else
    {
        $('#frmDeviceMgmt_DeviceHeaderDiv').css('right', '0px');
    }
    frmDeviceMgmt_DeviceEditMode();

    //For IE8
    //comment by ken 2015/02/17
    //    $("#frmDeviceMgmt_DeviceBody tr:nth-child(even) td").addClass("tblListEven");

    $$.LoadingMsg(false);
    if (frmDeviceMgmt_m_CurrentPage > frmDeviceMgmt_m_TotalPage)
    {
        frmDeviceMgmt_m_CurrentPage = frmDeviceMgmt_m_TotalPage;
        frmDeviceMgmt_DeviceFuzzySearch();
    }
}


function frmDeviceMgmt_DeviceFuzzySearchGroup()
{
    frmDeviceMgmt_log.info('call frmDeviceMgmt_DeviceFuzzySearchGroup func');
    if (frmDeviceGroup_m_CurrentGroup.attr("ItemType") == "Server")
    {
        $$.LoadingMsg(false);
    }
    if (frmDeviceGroup_m_CurrentGroup.attr("ItemType") == "Account")
    {
        $('#frmDeviceMgmt_FuzzySearchSpan').show();
        var xml = "<request></request>";
        var xmlDoc = $.parseXML(xml);

        var nodelang = $.cookie('selectedLang');
        nodelang = $.parseXML('<lang value="' + index_m_selectedLang.replace(/_/g, '-') + '"></lang>');
        $(xmlDoc).children(0).append($(nodelang).children(0));
        //clause
        var nodeClause = $.parseXML('<clause/>');
        var nodeItem;

        if (typeof frmDeviceGroup_m_CurrentGroup.attr("AccID") != 'undefined')
        {
            nodeItem = $.parseXML('<item name="account_id" value="' + frmDeviceGroup_m_CurrentGroup.attr("AccID") + '"></item>');
            $(nodeClause).children(0).append($(nodeItem).children(0));
        }
        if (frmDeviceMgmt_m_CurrentStateID != "")
        {
            nodeItem = $.parseXML('<item name="devicestate" value="' + frmDeviceMgmt_m_CurrentStateID + '"></item>');
            $(nodeClause).children(0).append($(nodeItem).children(0));
        }
        $(xmlDoc).children(0).append($(nodeClause).children(0));

        //like
        var strEscape = $$.EscapeString($.trim($('#frmDeviceMgmt_FuzzySearch').val()));
        var nodeLike = $.parseXML('<like  value="' + strEscape + '"></like>');
        $(xmlDoc).children(0).append($(nodeLike).children(0));

        //orderby
        var nodeOrderBy = $.parseXML('<orderby/>');
        nodeItem = $.parseXML('<item name="' + frmDeviceMgmt_m_SortBy + '" value="' + frmDeviceMgmt_m_SortType + '"></item>');
        $(nodeOrderBy).children(0).append($(nodeItem).children(0));
        //    nodeItem = $.parseXML('<item name="ts" value="DESC"></item>');  
        //    $(nodeOrderBy).children(0).append($(nodeItem).children(0));
        $(xmlDoc).children(0).append($(nodeOrderBy).children(0));

        //resultfilter
        var nodeResult = $.parseXML('<resultfilter/>');
        nodeItem = $.parseXML('<item name="page size" value="' + m_PageSize + '"></item>');
        $(nodeResult).children(0).append($(nodeItem).children(0));
        nodeItem = $.parseXML('<item name="page no" value="' + Math.max(frmDeviceMgmt_m_CurrentPage, 1) + '"></item>');
        $(nodeResult).children(0).append($(nodeItem).children(0));
        $(xmlDoc).children(0).append($(nodeResult).children(0));

        $global.Submit("/DeviceMgmt/groupFuzzySearch", "post", $$.xmlToString(xmlDoc), m_user, m_password, frmDeviceMgmt_DeviceFuzzySearchGroupCallback);
    }
    if (frmDeviceGroup_m_CurrentGroup.attr("ItemType") == "Group")
    {
        $('#frmDeviceMgmt_FuzzySearchSpan').hide();
        if (typeof frmDeviceGroup_m_CurrentGroup.attr("ItemValue") != 'undefined')
            $global.Submit("/DeviceMgmt/getGroupByID/" + frmDeviceGroup_m_CurrentGroup.attr("ItemValue"), "get", "", m_user, m_password, frmDeviceMgmt_DeviceFuzzySearchGroupCallback);
    }

}
function frmDeviceMgmt_DeviceFuzzySearchGroupCallback(xmlResponse)
{
    frmDeviceMgmt_log.info('call frmDeviceMgmt_DeviceFuzzySearchGroupCallback func');
    $('#frmDeviceMgmt_GroupHeaderDiv').show();
    $('#frmDeviceMgmt_GroupBodyDiv').show();
    $('#frmDeviceMgmt_DeviceHeaderDiv').hide();
    $('#frmDeviceMgmt_DeviceBodyDiv').hide();

    $('#frmDeviceMgmt_GroupBody tr').has('td').remove();
    frmDeviceMgmt_m_CurrentDevice = null;
    var strBrowser = navigator.detectBrowser.toString().split(',')[0];
    var strBrowserVer = navigator.detectBrowser.toString().split(',')[1];

    frmDeviceMgmt_log.debug('start to create table of device mgmt for group view');
    $(xmlResponse).find("item").each(function ()
    {
        var sTR = '<tr ItemType="group" AccountID="' + frmDeviceGroup_m_CurrentGroup.attr("AccID") + '" ItemValue="' + $(this).find("gid").text() + '" GroupName="' + $(this).find("name").text() + '" TotalDev="' + $(this).find("totaldev").text() + '" UpgradeDev="' + $(this).find("upgradedev").text() + '" LatestVersion="' + $(this).find("latestagentversion").text() + '" Lock="' + $(this).find("lock").text() + '" style="cursor: pointer;">';

        //Name
        if (parseInt($(this).find("upgradedev").text()) > 0)
        //if ((parseInt($(this).find("upgradedev").text()) > 0) && false)
        {
            var strDevstateIcon = "images/ico_update_40.png";
            sTR = sTR + '<td class="dev-cell"><span style="float: left; width: 24px;"><img class="devUpgrade" src="' + strDevstateIcon + '" style="width: 24px; height: 24px; vertical-align:middle; align: left; cursor: pointer;"></span>';
            sTR = sTR + '<span style="float: left; margin-left: 10px; width: 80%; text-overflow: ellipsis !important; overflow: hidden !important;"><a class="action-a" style="color: #000;" title="' + $(this).find("name").text() + '">' + $(this).find("name").text() + '</a></span></td>';
        }
        else
        {
            sTR = sTR + '<td class="dev-cell"><span style="float: left; width: 24px;"></span>';
            sTR = sTR + '<span style="float: left; margin-left: 34px; width: 80%; text-overflow: ellipsis !important; overflow: hidden !important;"><a class="action-a" style="color: #000;" title="' + $(this).find("name").text() + '">' + $(this).find("name").text() + '</a></span></td>';
        }

        //Hardware Status
        var strHWStatus = '<a class="action-a" style="color: #000;">' + $('#frmMessage_DeviceRegisterDevices').html() + " : " + $(this).find("totaldev").text() + '</a>';

        var nHWError = parseInt($(this).find("hwErrDev").text());
        if (parseInt($(this).find("hddErrDev").text()) > nHWError)
            nHWError = parseInt($(this).find("hddErrDev").text());
        if (parseInt($(this).find("netErrDev").text()) > nHWError)
            nHWError = parseInt($(this).find("netErrDev").text());

        if (nHWError > 0)
            strHWStatus = strHWStatus + "  ,  " + '<a class="action-a" style="color: red;">' + $('#frmMessage_DeviceAbNormal').html() + " : " + nHWError + '</a>';

        sTR = sTR + '<td class="dev-cell">' + '<span style="float: left; margin-left: 10px; width: 60%; text-overflow: ellipsis !important; overflow: hidden !important;">' + strHWStatus + '</span>';
        sTR = sTR + '<span style="float: right;"><img src="images/settings.png" class="hwSetting action-img1" style="width: 16px; height: 16px; vertical-align:middle; align: right;" title="' + $('#frmDeviceMgmt_txtDeviceHWRule').html() + '"></span></td>';

        //Software Status
        var strSWStatus = '<a class="action-a" style="color: #000;">' + $('#frmMessage_DeviceRegisterDevices').html() + " : " + $(this).find("totaldev").text() + '</a>';
        if (parseInt($(this).find("swErrDev").text()) > 0)
            strSWStatus = strSWStatus + "  ,  " + '<a class="action-a" style="color: red;">' + $('#frmMessage_DeviceAbNormal').html() + " : " + $(this).find("swErrDev").text() + '</a>';
        sTR = sTR + '<td class="dev-cell">' + '<span style="float: left; margin-left: 10px; width: 60%; text-overflow: ellipsis !important; overflow: hidden !important;">' + strSWStatus + '</span>';
        sTR = sTR + '<span style="float: right;"><img src="images/settings.png" class="swSetting action-img1" style="width: 16px; height: 16px; vertical-align:middle;" title="' + $('#frmDeviceMgmt_txtDeviceSWRule').html() + '"></span></td>';
        //sTR = sTR + '<td class="dev-cell">' + strHWStatus + '<span style=" float: right;"><img src="images/settings.png" class="action-img1" style="width: 16px; height: 16px; vertical-align:middle; align: right;" title="' + $('#frmDeviceMgmt_txtDeviceSWRule').html() + '"></span></td>';
        sTR = sTR + '</tr>';
        var oTR = $(sTR);
        $('#frmDeviceMgmt_GroupBody').append(oTR);
    });
    $('#frmDeviceMgmt_GroupBody').trigger('create');

    //Page
    frmDeviceMgmt_m_TotalPage = Math.ceil(parseInt($(xmlResponse).find("totalsize").text()) / m_PageSize);
    frmDeviceMgmt_m_CurrentPage = Math.max(frmDeviceMgmt_m_CurrentPage, 1);
    if (frmDeviceMgmt_m_TotalPage.toString() == '0')
    {
        $('#frmDeviceMgmt_GroupBodyDiv').hide();
        frmDeviceMgmt_m_CurrentPage = 0;
    }
    else
        $('#frmDeviceMgmt_GroupBodyDiv').show();

    $('#frmDeviceMgmt_PageIndecator').html(frmDeviceMgmt_m_CurrentPage + " / " + frmDeviceMgmt_m_TotalPage);

    frmDeviceMgmt_setPageNumber();
    frmDeviceMgmt_SetPageCanPress();

    if ((strBrowser.indexOf("MSIE") == 0) && (parseInt(strBrowserVer) <= 9))
        $("#frmDeviceMgmt_GroupBody td:empty").html('<span style="padding: 100%;"></span>');

    if ($('#frmDeviceMgmt_GroupBodyDiv').hasScrollBarH())
    {
        $('#frmDeviceMgmt_GroupHeaderDiv').css('right', '15px');
    }
    else
    {
        $('#frmDeviceMgmt_GroupHeaderDiv').css('right', '0px');
    }
    frmDeviceMgmt_DeviceEditMode();
    //For IE8
    $("#frmDeviceMgmt_GroupBody tr:nth-child(even) td").addClass("tblListEven");
    $$.LoadingMsg(false);
    if (frmDeviceMgmt_m_CurrentPage > frmDeviceMgmt_m_TotalPage)
    {
        frmDeviceMgmt_m_CurrentPage = frmDeviceMgmt_m_TotalPage;
        frmDeviceMgmt_DeviceFuzzySearchGroup();
    }
}
function frmDeviceMgmt_DeviceEditMode()
{
    frmDeviceMgmt_log.info('call frmDeviceMgmt_DeviceEditMode func');
    frmDeviceMgmt_log.debug('refresh device mgmt view mode:' + $.cookie('frmDeviceMgmt_ViewMode'));

    //Map / list mode
    switch ($.cookie('frmDeviceMgmt_ViewMode'))
    {
        case 'Map':
            var oMap = $('#frmDeviceMgmt_LocallMap').children(1);
            try
            {
                oMap.draggable({
                    start: function (event, ui) {
                    },
                    stop: function (event, ui) {
                    }
                });
            }
            catch (e) {
            }

            $('.MapItem').draggable({
                start: function (event, ui) {
                },
                stop: function (event, ui) {
                    var nWidth = $(this).parent().width();
                    var nHeight = $(this).parent().height();
                    var nTop = Math.max(0, (ui.helper.offset().top - $(this).parent().offset().top));
                    var nLeft = Math.max(0, (ui.helper.offset().left - $(this).parent().offset().left));
                    nTop = Math.min(nHeight - $(this).height(), nTop);
                    nLeft = Math.min(nWidth - $(this).width(), nLeft);
                    nLeft = parseFloat(nLeft / nWidth).toFixed(8);
                    nTop = parseFloat(nTop / nHeight).toFixed(8);
                    $(this).css({
                        left: nLeft * 100 + "%",
                        top: nTop * 100 + "%"
                    });
                    $(this).show();
                    $(this).attr("ItemLal", nLeft.toString() + ";" + nTop.toString());
                    frmDeviceMgmt_MapItemSetLal($(this).attr("ItemValue"), $(this).attr("ParentValue"), nLeft.toString() + ";" + nTop.toString());
                }
            });
//            $('.MapItem').draggable({
//                helper: "clone",
//                containment: "#index_Content",
//                appendTo: '#frmDeviceMap_MapDiv',
//                scroll: false,
//                zIndex: 9999,
//                start: function(event, ui) {
//                    $(this).hide();
//                    $(this).attr("DragToStop" , "true");
//                    frmDeviceMgmt_m_MapItemDroped = null;
//                    $("#index_pnlDeviceInfoWindow").hide();
//                    $('.MapList').find('a').removeClass("lstTreeFocus");
//                    frmDeviceMap_m_CurrentMapNode.DeviceID = $(this).attr("ItemValue");
//                },
//                stop: function(event, ui) {
//                    if ($(this).attr("DragToStop") == "false") return;
//                    var nWidth = $(this).parent().width();
//                    var nHeight = $(this).parent().height();
//                    var nTop = Math.max(0, (ui.helper.offset().top - $(this).parent().offset().top));
//                    var nLeft = Math.max(0, (ui.helper.offset().left - $(this).parent().offset().left));
//                    nTop = Math.min(nHeight - $(this).height() , nTop);
//                    nLeft = Math.min(nWidth - $(this).width() , nLeft);
//                    nLeft = parseFloat(nLeft / nWidth).toFixed(8);
//                    nTop = parseFloat(nTop / nHeight).toFixed(8);
//                    $(this).css({
//                        left:nLeft*100 + "%",
//                        top:nTop*100 + "%"
//                    });
//                    $(this).show();
////                    nLeft = parseFloat(nLeft / nWidth).toFixed(8);
////                    nTop = parseFloat(nTop / nHeight).toFixed(8);
//                    $(this).attr("ItemLal" , nLeft.toString() + ";" + nTop.toString());
//                    frmDeviceMgmt_MapItemSetLal($(this).attr("ItemValue") , $(this).attr("ParentValue") , nLeft.toString() + ";" + nTop.toString());
//                }    
//            });
            //Map
            if (index_m_DeviceEditMode)
            {
                $('.MapItem').draggable('enable');
                $('.MapItem').css('cursor', 'move');
                if (frmDeviceMap_m_MapType.toLowerCase() == "google")
                {
                    if (typeof m_GoogleMapMarkersArray == 'undefined')
                        return;
                    for (var i = 0; i < m_GoogleMapMarkersArray.length; i++) {
                        m_GoogleMapMarkersArray[i].setDraggable(true);
                    }
                }
                if (frmDeviceMap_m_MapType.toLowerCase() == "baidu")
                {
                    if (typeof m_BaiduMapMarkersArray == 'undefined')
                        return;
                    for (var i = 0; i < m_BaiduMapMarkersArray.length; i++) {
                        m_BaiduMapMarkersArray[i].enableDragging();
                    }
                }
                //frmDeviceMap_MapTreeDrop();
            }
            else
            {
                $('.MapItem').draggable('disable');
                $('.MapItem').css('cursor', 'default');
                if (frmDeviceMap_m_MapType.toLowerCase() == "google")
                {
                    if (typeof m_GoogleMapMarkersArray == 'undefined')
                        return;
                    for (var i = 0; i < m_GoogleMapMarkersArray.length; i++) {
                        m_GoogleMapMarkersArray[i].setDraggable(false);
                    }
                }
                if (frmDeviceMap_m_MapType.toLowerCase() == "baidu")
                {
                    if (typeof m_BaiduMapMarkersArray == 'undefined')
                        return;
                    for (var i = 0; i < m_BaiduMapMarkersArray.length; i++) {
                        m_BaiduMapMarkersArray[i].disableDragging();
                    }
                }
            }
            break;
        case 'Group':
        case 'List':
            //added by ken 20141027
            //always hide del row icon (還原SA30)
            //$('#frmDeviceMgmt_DeviceHeader th:nth-child(1),#frmDeviceMgmt_DeviceBody td:nth-child(1)').hide();

            if (index_m_DeviceEditMode)
            {
                frmDeviceMgmt_log.debug('edit mode');

                //added by ken 20150123
                //always hide del row icon (還原SA30)
                //打開第一個checkbox
                //$('#frmDeviceMgmt_DeviceHeader th:nth-child(1),#frmDeviceMgmt_DeviceBody td:nth-child(1)').show();
                $('#frmDeviceMgmt_Tab_DeviceList .del-cell-del').show();

                //added by ken 2016/01/16
                //還原已點開的sensor list
                $('#frmDeviceMgmt_DeviceBody img[src="images/minus.png"]').attr('src', 'images/plus.png');
                //關閉已經打開的hide ROW
                $('#frmDeviceMgmt_DeviceBody .hide-device').hide();

                frmDeviceMgmt_resetTableColumnOnIE8();
                //update by ken 20150123
                //change drag element index (還原SA30)
                var $draggableTdOfDevice = $('#frmDeviceMgmt_DeviceBody tr[ItemType="device"]').find('td:eq(1)');
                //                frmDeviceMgmt_log.debug('draggable devices: ' + $draggableTdOfDevice.length);

                $draggableTdOfDevice.draggable({
                    helper: function () {
                        frmDeviceMgmt_log.debug('edit mode: draggable helper');
                        //display tooltip helper
                        return $('<div style="white-space: nowrap; color: #fff !important; padding: 10px; opacity: 0.8; background-image: -webkit-linear-gradient(top, #869bb5, #91a6c1); -moz-border-radius: .3em .3em .3em .3em; -webkit-border-radius: .3em; border-radius: .3em .3em .3em .3em;"></div>').append(
                                $('#frmDeviceMgmt_DeviceHeader').find("th").eq(1).find("a").html() + ' : ' + $(this).parent().find("td").eq(1).find("a").html());
                    },
                    containment: "#index_Content",
                    appendTo: '#frmDeviceGroup_GroupDiv',
                    zIndex: 9999,
                    scroll: false,
                    start: function (event, ui) {
                        frmDeviceMgmt_m_CurrentDevice = $(this).parent();
                        frmDeviceMgmt_m_Draging = true;
                    },
                    stop: function (event, ui) {
                        frmDeviceMgmt_m_Draging = false;
                        //frmDeviceMgmt_DeviceFuzzySearch();
                    }
                });



//                frmDeviceGroup_TreeDrop();
            }
            else
            {
                frmDeviceMgmt_log.debug('normal mode');

                if ($("#frmDeviceGroup_GroupUL li").hasClass('ui-droppable'))
                    $("#frmDeviceGroup_GroupUL li").droppable('destroy');

//                if($('#frmDeviceMgmt_DeviceBody tr[ItemType="device"] td').hasClass('ui-draggable'))
//                    $('#frmDeviceMgmt_DeviceBody tr[ItemType="device"] td').draggable('destroy');

                //$('#frmDeviceMgmt_DeviceHeader th:nth-child(1),#frmDeviceMgmt_DeviceBody td:nth-child(1)').hide();
                $('#frmDeviceMgmt_Tab_DeviceList .del-cell-del').hide();
                $('#frmDeviceMgmt_DeviceBody').find('.EditMode').hide();

                //2016/1/6 close hide-device row
                $('#frmDeviceMgmt_DeviceBody img[src="images/minus.png"]').attr('src', 'images/plus.png');
                $('#frmDeviceMgmt_DeviceBody .hide-device').hide();
                //                     frmDeviceMgmt_resetTableColumnOnIE8();

            }
            if ($.inArray("a", privilege_array) > -1)
            {
                $('.EditMode').show();
                $('.ViewMode').hide();
            }
            else
            {
                $('.EditMode').hide();
                $('.ViewMode').show();
            }
            //Connect status
            $('#frmDeviceMgmt_DeviceBody tr').each(function ()
            {
                if ($(this).attr('DeviceStatus') == "Connected")
                {
                    $(this).find("td").eq(1).find('.devKVM, .devTerminal').eq(1).removeClass('ui-disabled');
                    $(this).find("td").eq(1).find('.devKVM, .devTerminal').eq(1).removeAttr('disabled');
                }
                else
                {
                    $(this).find("td").eq(1).find('.devKVM, .devTerminal').addClass('ui-disabled');
                    $(this).find("td").eq(1).find('.devKVM, .devTerminal').attr('disabled', 'disabled');
                }
                if ($.inArray("e", privilege_array) == -1) {
                    $(this).find("td").eq(1).find('.devKVM, .devTerminal').addClass('ui-disabled');
                    $(this).find("td").eq(1).find('.devKVM, .devTerminal').attr('disabled', 'disabled');
                }

            });
            break;
    }
}
function frmDeviceMgmt_setPageNumber()
{
    $('#frmDeviceMgmt_selectDivText').hide();
    $('#frmDeviceMgmt_selectDiv').show();

    $('#frmDeviceMgmt_selectPage').find('option').remove();
    if (frmDeviceMgmt_m_TotalPage.toString() == '0')
    {
        frmDeviceMgmt_m_CurrentPage = 0;
        $('select#frmDeviceMgmt_selectPage').append('<option value=' + frmDeviceMgmt_m_CurrentPage.toString() + '>' + frmDeviceMgmt_m_TotalPage.toString() + '</option>');
    }
    else
    {
        var strOption = "";
        for (var i = 1; i <= parseInt(frmDeviceMgmt_m_TotalPage); i++)
            strOption = strOption + '<option value=' + i.toString() + '>' + i + '</option>';
        $('select#frmDeviceMgmt_selectPage').append(strOption);
    }

    $('select#frmDeviceMgmt_selectPage').val(frmDeviceMgmt_m_CurrentPage);

    $("select#frmDeviceMgmt_selectPage").selectmenu('refresh', true);
}
function frmDeviceMgmt_SetPageCanPress()
{
    if (frmDeviceMgmt_m_CurrentPage <= 1)
    {
        $('#frmDeviceMgmt_PageFirst').addClass('ui-disabled');
        $('#frmDeviceMgmt_PageFirst').attr('disabled', 'disabled');
        $('#frmDeviceMgmt_PagePrevious').addClass('ui-disabled');
        $('#frmDeviceMgmt_PagePrevious').attr('disabled', 'disabled');
    }
    else
    {
        $('#frmDeviceMgmt_PageFirst').removeClass('ui-disabled');
        $('#frmDeviceMgmt_PageFirst').removeAttr('disabled');
        $('#frmDeviceMgmt_PagePrevious').removeClass('ui-disabled');
        $('#frmDeviceMgmt_PagePrevious').removeAttr('disabled');
    }

    if (frmDeviceMgmt_m_CurrentPage >= frmDeviceMgmt_m_TotalPage)
    {
        $('#frmDeviceMgmt_PageNext').addClass('ui-disabled');
        $('#frmDeviceMgmt_PageNext').attr('disabled', 'disabled');
        $('#frmDeviceMgmt_PageLast').addClass('ui-disabled');
        $('#frmDeviceMgmt_PageLast').attr('disabled', 'disabled');
    }
    else
    {
        $('#frmDeviceMgmt_PageNext').removeClass('ui-disabled');
        $('#frmDeviceMgmt_PageNext').removeAttr('disabled');
        $('#frmDeviceMgmt_PageLast').removeClass('ui-disabled');
        $('#frmDeviceMgmt_PageLast').removeAttr('disabled');
    }
}
function frmDeviceMgmt_PageOperation()
{

    $("#frmDeviceMgmt_selectPage").live("change", function (e) {
        $('#frmDeviceMgmtPageChange_btnOK').click();
    });

    $("#frmDeviceMgmt_selectPageText").keypress(function (e) {
        var bvalid = false;
        if (e.which > 47 && e.which < 58)
            bvalid = true;
        return bvalid;
    });

    $('#frmDeviceMgmt_selectPageText').keyup(function () {
        if ($(this).val() > frmDeviceMgmt_m_TotalPage)
            $(this).val(frmDeviceMgmt_m_TotalPage);

        if ($(this).val() < 0)
        {
            if (frmDeviceMgmt_m_TotalPage == 0)
                $(this).val(0);
            else if (frmDeviceMgmt_m_TotalPage > 0)
                $(this).val(1);
        }
    })

    $('#frmDeviceMgmt_search').live('keyup', function () {
        frmDeviceMgmt_m_CurrentPage = 1;
        frmDeviceMgmt_DeviceFuzzySearch();
        frmDeviceMgmt_SetPageCanPress();
    });

    $('#frmDeviceMgmt_searchspan .ui-input-clear').live('click', function () {
        frmDeviceMgmt_m_CurrentPage = 1;
        frmDeviceMgmt_DeviceFuzzySearch();
        frmDeviceMgmt_SetPageCanPress();
    })

    $('#frmDeviceMgmtPageChange_btnOK').click(function () {
        frmDeviceMgmt_m_CurrentPage = parseInt($('select#frmDeviceMgmt_selectPage').val());
        $$.LoadingMsg(true);
        frmDeviceMgmt_DeviceFuzzySearch();
        frmDeviceMgmt_SetPageCanPress();
    })

    $('#frmDeviceMgmt_PageFirst').click(function () {
        if(frmDeviceMgmt_m_CurrentPage <= 1)
            return;
        $('select#frmDeviceMgmt_selectPage').val(1);
        $('#frmDeviceMgmtPageChange_btnOK').click();
    })

    $('#frmDeviceMgmt_PagePrevious').click(function () {
        frmDeviceMgmt_m_CurrentPage = frmDeviceMgmt_m_CurrentPage - 1;
        if (frmDeviceMgmt_m_CurrentPage < 1)
            return;

        $('select#frmDeviceMgmt_selectPage').val(frmDeviceMgmt_m_CurrentPage);
        $('#frmDeviceMgmtPageChange_btnOK').click();
    })

    $('#frmDeviceMgmt_PageNext').click(function () {
        frmDeviceMgmt_m_CurrentPage = frmDeviceMgmt_m_CurrentPage + 1;
        if (frmDeviceMgmt_m_CurrentPage > frmDeviceMgmt_m_TotalPage)
            return;

        $('select#frmDeviceMgmt_selectPage').val(frmDeviceMgmt_m_CurrentPage);
        $('select#frmDeviceMgmt_selectPage').val(frmDeviceMgmt_m_CurrentPage);
        $('#frmDeviceMgmtPageChange_btnOK').click();
    })

    $('#frmDeviceMgmt_PageLast').click(function () {
        if(frmDeviceMgmt_m_CurrentPage >= frmDeviceMgmt_m_TotalPage)
            return;
        $('select#frmDeviceMgmt_selectPage').val(frmDeviceMgmt_m_TotalPage);
        $('#frmDeviceMgmtPageChange_btnOK').click();
    })
}

function frmDeviceMgmt_EditMaintainState(strState)
{
    $$.LoadingMsg(true);
    var xml = "<request></request>";
    var xmlDoc = $.parseXML(xml);
    var nodeParent = $.parseXML('<device/>');
    var nodeItem = $.parseXML('<item name="mainstate" value="' + strState + '"></item>');
    $(nodeParent).children(0).append($(nodeItem).children(0));
    $(xmlDoc).children(0).append($(nodeParent).children(0));
    $global.Submit("/DeviceMgmt/" + frmDeviceMgmt_m_CurrentDevice.attr("ItemValue"), "put", $$.xmlToString(xmlDoc), m_user, m_password, frmDeviceMgmt_EditMaintainStateCallback);
}
function frmDeviceMgmt_EditMaintainStateCallback(xmlResponse)
{
    if ($(xmlResponse).find('result').text() == "true")
    {
        //frmDeviceMgmt_m_CurrentDevice.find("td").eq(4).find('.ViewMode').html(frmDeviceMgmt_m_CurrentDevice.find("td").eq(4).find('.ViewMode').attr("Selectedtext"));
        frmDeviceMgmt_DeviceFuzzySearch();
        $$.LoadingMsg(false);
    }
    else
    {
        $$.MessageBox("error", $('#frmMessage_ModifyFailed').html());
    }
}
function frmDeviceMgmt_DeviceUpgrade(strAgentId)
{
    if (typeof frmDeviceUpgrade_initialize == 'undefined')
    {
        $('#index_pnlDeviceUpgrade').load('frmDeviceUpgrade.html?d=' + escape(Date()), function () {
            $('#index_pnlDeviceUpgrade').trigger('create');
            $global.faddingShow(true);
            frmDeviceUpgrade_m_Hidefadding = true;
            frmDeviceUpgrade_initialize(strAgentId);
            $('#index_pnlDeviceUpgrade').show();
        })
    }
    else
    {
        $global.faddingShow(true);
        frmDeviceUpgrade_m_Hidefadding = true;
        frmDeviceUpgrade_initialize(strAgentId);
        $('#index_pnlDeviceUpgrade').show();
    }
}

function frmDeviceMgmt_GroupUpgrade(strGroupId, strGroupName, strQty, strUpgradeVersion, strLock)
{
    if (typeof frmGroupUpgrade_initialize == 'undefined')
    {
        $('#index_pnlGroupUpgrade').load('frmGroupUpgrade.html?d=' + escape(Date()), function () {
            $('#index_pnlGroupUpgrade').trigger('create');
            $global.faddingShow(true);
            frmGroupUpgrade_initialize(strGroupId, strGroupName, strQty, strUpgradeVersion, strLock);
            $('#index_pnlGroupUpgrade').show();
        })
    }
    else
    {
        $global.faddingShow(true);
        frmGroupUpgrade_initialize(strGroupId, strGroupName, strQty, strUpgradeVersion, strLock);
        $('#index_pnlGroupUpgrade').show();
    }
}

function frmDeviceMgmt_AMTKVMInfo(strAgentId, devStatus, deviceIP, amtSupport, kvmMode, custPort, custPwd, deviceName, osVersion)
{
    frmDeviceMgmt_m_KVMIP = deviceIP;
    frmVNCView_deviceStatus = devStatus;
    frmVNCView_deviceName = deviceName;
    frmVNCView_osVersion = osVersion;
    $global.Submit("/DeviceMgmt/setIAMT/", "post", frmDeviceMgmt_GetAMTVNCData(strAgentId), m_user, m_password, frmDeviceMgmt_iAMTKVMCallback);     // iAMT vnc server
}

function frmDeviceMgmt_AMTNoVNCInfo(strAgentId, devStatus, deviceIP, amtSupport, kvmMode, custPort, custPwd, deviceName, osVersion)
{
    frmDeviceMgmt_m_KVMIP = location.toString().split(':')[1].replace(/\//g, '');
    frmVNCView_osVersion = osVersion;
    frmVNCView_deviceStatus = devStatus;
    frmVNCView_deviceName = deviceName;
    frmNoVNCView_openViewer(true, frmVNCView_deviceName);
}

function frmDeviceMgmt_noVNCInfo(strAgentId, devStatus, deviceIP, amtSupport, kvmMode, custPort, custPwd, deviceName, osVersion)
{
//    frmNoVNCViewSend_CustVNC1(deviceIP, custPort, custPwd, deviceName);  
    frmDeviceMgmt_m_AgentID = strAgentId;
    frmVNCView_osVersion = osVersion;
    if (devStatus.toString().toLowerCase() === 'connected') {
        if (kvmMode.toString().toLowerCase() === 'default') {
            if(window.location.protocol === "https:"){
                frmNoVNCView_openViewer(false, deviceName);
                frmNoVNCViewSend_Repeater();
            }else{
                frmNoVNCViewSend_Normal(deviceName);
            }            
        }

        else if (kvmMode.toString().toLowerCase() === 'customvnc')
        {
            if(window.location.protocol === "https:"){
                $$.MessageDialog(frmMsgDialog_MsgType.error, $('#frmDeviceMgmt_szSSLNotSupportCustomKVM').html(), frmMsgDialog_BtnType.OK);
            }else{
                frmNoVNCViewSend_CustVNC(deviceIP, custPort, custPwd, deviceName);
            }            
        }
    }
}

function frmNoVNCViewSetPwd(devIP, custPort, deviceName)
{
    if (typeof frmDeviceMgmtSetNoVNCCustPwd_initialize == 'undefined')
    {
        $('#index_pnlKvmSetNoVNCCustPwd').load('frmDeviceMgmtSetNoVNCCustPwd.html?d=' + escape(Date()), function () {
            $('#index_pnlKvmSetNoVNCCustPwd').trigger('create');
            $global.faddingShow(true);
            setTimeout(function () {
                frmDeviceMgmtSetNoVNCCustPwd_initialize(devIP, custPort, deviceName);
            }, 100)
        });
    }
    else
    {
        $global.faddingShow(true);
        setTimeout(function () {
            frmDeviceMgmtSetNoVNCCustPwd_initialize(devIP, custPort, deviceName);
        }, 100)
    }
    $('#index_pnlKvmSetNoVNCCustPwd').fadeIn();
}

function frmDeviceMgmt_KVMInfo(strAgentId, devStatus, deviceIP, amtSupport, kvmMode, custPort, custPwd, deviceName, osVersion)
{
    //    $$.LoadingMsg(true);
    frmVNCView_isCustMode = false;
    frmDeviceMgmt_m_AgentID = strAgentId;
    frmVNCView_osVersion = osVersion;
    //    frmVNCView_isUseAMT = false;
    if (index_isSeparateKVMAMT)
    {
        if (devStatus.toString().toLowerCase() == 'connected')
        {
            if (kvmMode.toString().toLowerCase() == 'default')
                //                    frmVNCViewpreSend_Repeater();
                frmVNCViewSend_Normal(deviceName);
            else if (kvmMode.toString().toLowerCase() == 'customvnc')
            {
                if (custPwd != 'na')
                    frmVNCViewSend_CustVNC(deviceIP, custPort, custPwd, deviceName);
                else
                    frmVNCViewSetPwd(deviceIP, custPort, deviceName);
            }
        }
    }
    else
    {
        if (amtSupport == 'true')
        {
            if (devStatus.toString().toLowerCase() == 'connected')
            {
                if (kvmMode.toString().toLowerCase() == 'default')
                    frmVNCViewSend_Normal(deviceName);
                else if (kvmMode.toString().toLowerCase() == 'customvnc')
                {
                    if (custPwd != 'na')
                        frmVNCViewSend_CustVNC(deviceIP, custPort, custPwd, deviceName);
                    else
                        frmVNCViewSetPwd(deviceIP, custPort, deviceName);
                }
            }
            else
            {
                frmDeviceMgmt_m_KVMIP = deviceIP;
                $global.Submit("/DeviceMgmt/setIAMT/", "post", frmDeviceMgmt_GetAMTVNCData(strAgentId), m_user, m_password, frmDeviceMgmt_iAMTKVMCallback);     // iAMT vnc server
            }
        }
        else
        {
            if (devStatus.toString().toLowerCase() == 'connected')
            {
                if (kvmMode.toString().toLowerCase() == 'default')
                    //                    frmVNCViewpreSend_Repeater();
                    frmVNCViewSend_Normal(deviceName);
                else if (kvmMode.toString().toLowerCase() == 'customvnc')
                {
                    if (custPwd != 'na')
                        frmVNCViewSend_CustVNC(deviceIP, custPort, custPwd, deviceName);
                    else
                        frmVNCViewSetPwd(deviceIP, custPort, deviceName);
                }
            }
        }
    }
}

function frmDeviceMgmt_iAMTKVMCallback(xmlResponse)
{
    if ($(xmlResponse).find('result').text() == 'true')
    {
        frmVNCView_openVncViewer(true, frmVNCView_deviceName);
        setTimeout(function () {
            frmDeviceMgmt_m_KVMPort = '5900';
            frmDeviceMgmt_m_KVMMode = 5;   //iAMT VNC
            VNCViewerInitialize(frmDeviceMgmt_m_KVMMode, frmDeviceMgmt_m_KVMIP, frmDeviceMgmt_m_KVMPassword, frmDeviceMgmt_m_KVMPort,
                    5500, frmDeviceMgmt_m_KVMRepeaterIP, frmDeviceMgmt_m_KVMRepeaterID);
        }, 5000)
    }
}

function frmDeviceMgmt_iAMTNoVNCCallback(xmlResponse)
{
    if ($(xmlResponse).find('result').text() == 'true')
    {
        frmDeviceMgmt_m_KVMPort = '6080';
        frmDeviceMgmt_m_KVMMode = 5;   //iAMT VNC
//        frmNoVNCView_openViewer(true, frmVNCView_deviceName);  
        if ($('#index_pnlDeviceNoVNC').is(':visible')) {
            NoVNCViewerInitialize(frmDeviceMgmt_m_KVMMode, frmDeviceMgmt_m_KVMIP, frmDeviceMgmt_m_KVMPassword, frmDeviceMgmt_m_KVMPort,
                    5500, frmDeviceMgmt_m_KVMRepeaterIP, '');
        }
    }
}

function frmDeviceMgmt_GetAMTVNCData(strAgentId)
{
    var xml = "<request></request>";
    var xmlDoc = $.parseXML(xml);
    var itemNodeContent = '<item name="agentId" value="' + strAgentId + '"></item>';
    var itemNode = $.parseXML(itemNodeContent);
    $(xmlDoc).children(0).append($(itemNode).children(0));
    itemNodeContent = '<item name="action" value="kvm"></item>';
    itemNode = $.parseXML(itemNodeContent);
    $(xmlDoc).children(0).append($(itemNode).children(0));
    frmDeviceMgmt_m_KVMPassword = frmDeviceMgmt_GeneratorPassword();
    //frmDeviceMgmt_m_KVMPassword = '1qaz@WSX';
    itemNodeContent = '<item name="kvmpwd" value="' + frmDeviceMgmt_m_KVMPassword + '"></item>';
    itemNode = $.parseXML(itemNodeContent);
    $(xmlDoc).children(0).append($(itemNode).children(0));
    return $$.xmlToString(xmlDoc);
}

function frmDeviceMgmt_GeneratorPassword()
{
    var wordnumber = '0123456789';
    var wordLLeter = 'ABCDEFGHIJKLMNPQRSTUVWXYZ';
    var wordSLeter = 'abcdefghijkmnpqrstuvwxyz';
    var wordSymbol = '@$%^';
    var word;
    var password = '';
    for (var i = 0; i < 4; i++) {
        switch (i)
        {
            case 0:
                word = wordnumber;
                break;
            case 1:
                word = wordLLeter;
                break;
            case 2:
                word = wordSLeter;
                break;
            case 3:
                word = wordSymbol;
                break;
        }

        var len = word.length;
        for (var j = 0; j < 2; j++)
        {
            var randint = Math.floor(Math.random() * (1000 - 0));
            password = password + word[randint % len];
        }
    }
    return password;
}

function frmDeviceMgmt_KVMInfoCallback(xmlResponse)
{
    frmDeviceMgmt_m_KVMIP = $(xmlResponse).find("IP").text();
    frmDeviceMgmt_m_KVMPort = $(xmlResponse).find("Port").text();
    frmDeviceMgmt_m_KVMPassword = $(xmlResponse).find("Password").text();
    //    frmVNCViewpreSend_Repeater();
    frmVNCViewSend_Normal();
//    frmVNCView_GetServerIP();
//    if(typeof VNCViewerInitialize == 'undefined')
//    {
//        $('#index_pnlDeviceVNC').load('VncViewer.html?d=' + escape(Date()),function(){  
//            $('#index_pnlDeviceVNC').trigger('create');                
//            VNCViewerInitialize();
//            $$.LoadingMsg(false);
//            $global.faddingShow(true);
//            $('#index_pnlDeviceVNC').show();    
//        })
//    }
//    else
//    {
//        VNCViewerInitialize();
//        $$.LoadingMsg(false);
//        $global.faddingShow(true);
//        $('#index_pnlDeviceVNC').show();    
//    }
}

function frmVNCViewSetPwd(devIP, custPort, deviceName)
{
    if (typeof frmDeviceMgmtSetCustPwd_initialize == 'undefined')
    {
        $('#index_pnlKvmSetCustPwd').load('frmDeviceMgmtSetCustPwd.html?d=' + escape(Date()), function () {
            $('#index_pnlKvmSetCustPwd').trigger('create');
            $global.faddingShow(true);
            setTimeout(function () {
                frmDeviceMgmtSetCustPwd_initialize(devIP, custPort, deviceName);
            }, 100)
        });
    }
    else
    {
        $global.faddingShow(true);
        setTimeout(function () {
            frmDeviceMgmtSetCustPwd_initialize(devIP, custPort, deviceName);
        }, 100)
    }
    $('#index_pnlKvmSetCustPwd').fadeIn();
}

function frmNoVNCViewSend_CustVNC1(devIP, custPort, custPwd, deviceName) {
    if (typeof NoVNCViewerInitialize == 'undefined')
    {
        $('#index_pnlDeviceNoVNC').load('NoVncViewer.html?d=' + escape(Date()), function () {
            $('#index_pnlDeviceNoVNC').trigger('create');
            $global.faddingShow(true);
            NoVNCViewerInitialize(1, '172.22.12.194', '1111', '6080', 0, 0, '');
//            $('#frmNoVNC_LoadingMsg').show();
            $('#index_pnlDeviceNoVNC').show();
        });
    }
    else
    {
        $global.faddingShow(true);
        NoVNCViewerInitialize(1, '172.22.12.195', '1111', '6080', 0, 0, '');
//        $('#frmNoVNC_LoadingMsg').show();
        $('#index_pnlDeviceNoVNC').show();
    }
}

function frmNoVNCViewSend_CustVNC(devIP, custPort, custPwd, deviceName)
{
    frmVNCView_isCustMode = true;
    frmDeviceMgmt_m_KVMMode = 1;
    frmDeviceMgmt_m_KVMIP = devIP;
    frmDeviceMgmt_m_KVMPort = custPort;
    frmDeviceMgmt_m_KVMPassword = custPwd;

    frmNoVNCView_openViewer(false, deviceName);
}

function frmVNCViewSend_CustVNC(devIP, custPort, custPwd, deviceName)
{
    frmVNCView_isCustMode = true;
    frmDeviceMgmt_m_KVMMode = 1;
    frmDeviceMgmt_m_KVMIP = devIP;
    frmDeviceMgmt_m_KVMPort = custPort;
    frmDeviceMgmt_m_KVMPassword = custPwd;
    //    alert(devIP + '   ' + custPort + '    ' + custPwd)
    frmVNCView_openVncViewer(false, deviceName);
}

function frmNoVNCViewSend_Normal(deviceName)
{
    //    alert(frmVNCView_getData());
    frmDeviceMgmt_m_KVMMode = 1;
    frmNoVNCView_openViewer(false, deviceName);

    $global.Submit("/KVMMgmt", "post", frmVNCView_getNormalData(), m_user, m_password, frmNoVNCViewSend_NormalCallback);
}

function frmNoVNCViewSend_NormalCallback(xml_string)
{
    if ($(xml_string).find('result').text() == 'false')
    {
        return;
    }
    var frmDeviceMgmt_m_KVMIP = $(xml_string).find("IP").text();
    var frmDeviceMgmt_m_KVMPort = $(xml_string).find("port").text();
    var frmDeviceMgmt_m_KVMPassword = $(xml_string).find("password").text();
//    alert(frmDeviceMgmt_m_KVMIP + ' ' + frmDeviceMgmt_m_KVMPort + ' ' + frmDeviceMgmt_m_KVMPassword)
    if ($('#index_pnlDeviceNoVNC').is(':visible')) {
        NoVNCViewerInitialize(frmDeviceMgmt_m_KVMMode, frmDeviceMgmt_m_KVMIP, frmDeviceMgmt_m_KVMPassword, '6081',
                5500, frmDeviceMgmt_m_KVMRepeaterIP, '');
    }
}

function frmNoVNCView_openViewer(isAMT, deviceName) {
    if (typeof NoVNCViewerInitialize == 'undefined')
    {
        $('#index_pnlDeviceNoVNC').load('NoVncViewer.html?d=' + escape(Date()), function () {
            $('#index_pnlDeviceNoVNC').trigger('create');
            $global.faddingShow(true);
            NoVncViewer_PreSetting(isAMT, frmVNCView_isCustMode, frmDeviceMgmt_m_SelectAgentID, deviceName, frmVNCView_osVersion);
            if (frmVNCView_isCustMode) {
                setTimeout(function(){
                    if ($('#index_pnlDeviceNoVNC').is(':visible')) {
                        NoVNCViewerInitialize(frmDeviceMgmt_m_KVMMode, frmDeviceMgmt_m_KVMIP, frmDeviceMgmt_m_KVMPassword, '6081',
                                5500, frmDeviceMgmt_m_KVMRepeaterIP, '');
                    }
                }, 1000);
                
            }
            if (isAMT) {
                $global.Submit("/DeviceMgmt/setIAMT/", "post", frmDeviceMgmt_GetAMTVNCData(frmDeviceMgmt_m_SelectAgentID), m_user, m_password, frmDeviceMgmt_iAMTNoVNCCallback);     // iAMT vnc server
            }

            $('#frmNoVNC_LoadingMsg').show();
            $('#index_pnlDeviceNoVNC').show();
        });
    }
    else
    {
        $global.faddingShow(true);
        NoVncViewer_PreSetting(isAMT, frmVNCView_isCustMode, frmDeviceMgmt_m_SelectAgentID, deviceName, frmVNCView_osVersion);
        if (frmVNCView_isCustMode) {
            setTimeout(function(){
                if ($('#index_pnlDeviceNoVNC').is(':visible')) {
                    NoVNCViewerInitialize(frmDeviceMgmt_m_KVMMode, frmDeviceMgmt_m_KVMIP, frmDeviceMgmt_m_KVMPassword, '6081',
                            5500, frmDeviceMgmt_m_KVMRepeaterIP, '');
                }
            }, 1000);
            
        }
        if (isAMT) {
            $global.Submit("/DeviceMgmt/setIAMT/", "post", frmDeviceMgmt_GetAMTVNCData(frmDeviceMgmt_m_SelectAgentID), m_user, m_password, frmDeviceMgmt_iAMTNoVNCCallback);     // iAMT vnc server
        }
        $('#frmNoVNC_LoadingMsg').show();
        $('#index_pnlDeviceNoVNC').show();
    }
}

function frmVNCViewSend_Normal(deviceName)
{
    //    alert(frmVNCView_getData());
    frmDeviceMgmt_m_KVMMode = 1;
    frmVNCView_openVncViewer(false, deviceName);
    $global.Submit("/KVMMgmt", "post", frmVNCView_getNormalData(), m_user, m_password, frmVNCViewSend_NormalCallback);
}

function frmVNCViewSend_NormalCallback(xml_string)
{
    if ($(xml_string).find('result').text() == 'false')
    {
        return;
    }
    frmDeviceMgmt_m_KVMIP = $(xml_string).find("IP").text();
    frmDeviceMgmt_m_KVMPort = $(xml_string).find("port").text();
    frmDeviceMgmt_m_KVMPassword = $(xml_string).find("password").text();
    VNCViewerInitialize(frmDeviceMgmt_m_KVMMode, frmDeviceMgmt_m_KVMIP, frmDeviceMgmt_m_KVMPassword, frmDeviceMgmt_m_KVMPort,
            5500, frmDeviceMgmt_m_KVMRepeaterIP, frmDeviceMgmt_m_KVMRepeaterID);
//    frmVNCView_openVncViewer();
}

function frmVNCView_getNormalData()
{
    var xml = "<request></request>";
    var xmlDoc = $.parseXML(xml);
    var itemNodeContent = '<item name="agentId" value="' + frmDeviceMgmt_m_AgentID + '"></item>';
    var itemNode = $.parseXML(itemNodeContent);
    $(xmlDoc).children(0).append($(itemNode).children(0));
    itemNodeContent = '<item name="mode" value="' + '1' + '"></item>';
    itemNode = $.parseXML(itemNodeContent);
    $(xmlDoc).children(0).append($(itemNode).children(0));
    return $$.xmlToString(xmlDoc);
}

function frmDeviceMgmt_openTerminal(agentID, agentName, agentOS)
{
    if (typeof frmDevice_Terminal_initialize == 'undefined')
    {
        $('#index_pnlDeviceTerminal').load('frmDevice_Terminal.html?d=' + escape(Date()), function () {
            $('#index_pnlDeviceTerminal').trigger('create');
            frmDevice_Terminal_initialize(agentID, agentName, agentOS);
            $$.LoadingMsg(false);
            $global.faddingShow(true);
            //            VncViewer_m_Hidefadding = true;
            $('#index_pnlDeviceTerminal').show();
        });
    }
    else
    {
        frmDevice_Terminal_initialize(agentID, agentName, agentOS);
        $$.LoadingMsg(false);
        $global.faddingShow(true);
        //        VncViewer_m_Hidefadding = true;
        $('#index_pnlDeviceTerminal').show();
    }
}

function frmDeviceMgmt_iAMT(strAgentId, strAgentName)
{
    if (typeof frmDeviceiAMT_initialize == 'undefined')
    {
        $('#index_pnlDeviceiAMT').load('frmDeviceiAMT.html?d=' + escape(Date()), function () {
            $('#index_pnlDeviceiAMT').trigger('create');
            $global.faddingShow(true);
            frmDeviceiAMT_initialize(strAgentId, strAgentName);
            $('#index_pnlDeviceiAMT').show();
        })
    }
    else
    {
        $global.faddingShow(true);
        frmDeviceiAMT_initialize(strAgentId, strAgentName);
        $('#index_pnlDeviceiAMT').show();
    }
}

function frmDeviceMgmt_Screenshot(strAgentId, strAgentName)
{
    if (typeof frmDevice_SS_initialize == 'undefined')
    {
        $('#index_pnlDeviceSS').load('frmDevice_SS.html?d=' + escape(Date()), function () {
            $('#index_pnlDeviceSS').trigger('create');
            $global.faddingShow(true);
            frmDevice_SS_initialize(strAgentId, strAgentName);
            $('#index_pnlDeviceSS').show();
        })
    }
    else
    {
        $global.faddingShow(true);
        frmDevice_SS_initialize(strAgentId, strAgentName);
        $('#index_pnlDeviceSS').show();
    }
}

function frmVNCView_openVncViewer(isiAMT, deviceName)
{
    if (typeof VNCViewerInitialize == 'undefined')
    {
        $('#index_pnlDeviceVNC').load('VncViewer.html?d=' + escape(Date()), function () {
            $('#index_pnlDeviceVNC').trigger('create');
            VncViewer_PreSetting(isiAMT, frmVNCView_isCustMode, frmDeviceMgmt_m_SelectAgentID, deviceName, frmVNCView_osVersion);
            if (frmVNCView_isCustMode)
            {
                VNCViewerInitialize(frmDeviceMgmt_m_KVMMode, frmDeviceMgmt_m_KVMIP, frmDeviceMgmt_m_KVMPassword, frmDeviceMgmt_m_KVMPort,
                        5500, frmDeviceMgmt_m_KVMRepeaterIP, frmDeviceMgmt_m_KVMRepeaterID);
            }

            $$.LoadingMsg(false);
            $global.faddingShow(true);
            VncViewer_m_Hidefadding = true;
            $('#frmVNC_LoadingMsg').show();
            $('#index_pnlDeviceVNC').show();
        })
    }
    else
    {
        VncViewer_PreSetting(isiAMT, frmVNCView_isCustMode, frmDeviceMgmt_m_SelectAgentID, deviceName, frmVNCView_osVersion);
        if (frmVNCView_isCustMode)
        {
            VNCViewerInitialize(frmDeviceMgmt_m_KVMMode, frmDeviceMgmt_m_KVMIP, frmDeviceMgmt_m_KVMPassword, frmDeviceMgmt_m_KVMPort,
                    5500, frmDeviceMgmt_m_KVMRepeaterIP, frmDeviceMgmt_m_KVMRepeaterID);
        }

        $$.LoadingMsg(false);
        $global.faddingShow(true);
        VncViewer_m_Hidefadding = true;
        $('#frmVNC_LoadingMsg').show();
        $('#index_pnlDeviceVNC').show();
    }
}

function frmVNCViewpreSend_Repeater()
{
    //    alert(location.toString())
    //    frmVNCView_openVncViewer();
    frmVNCViewSend_Repeater();
}

function frmNoVNCViewSend_Repeater() {
//    frmNoVNCView_openViewer(false, 'abc');
    $global.Submit("/KVMMgmt", "post", frmVNCView_getRepeaterData(), m_user, m_password, frmNoVNCViewSend_RepeaterCallback);
}

function frmNoVNCViewSend_RepeaterCallback(xml_string) {
    frmDeviceMgmt_m_KVMIP = $(xml_string).find("IP").text();
    frmDeviceMgmt_m_KVMPort = $(xml_string).find("port").text();
    frmDeviceMgmt_m_KVMPassword = $(xml_string).find("password").text();
    frmDeviceMgmt_m_KVMRepeaterIP = location.toString().split(':')[1].replace(/\//g, '');
    frmDeviceMgmt_m_KVMMode = 3;
    if ($('#index_pnlDeviceNoVNC').is(':visible')) {
        NoVNCViewerInitialize(frmDeviceMgmt_m_KVMMode, frmDeviceMgmt_m_KVMRepeaterIP, frmDeviceMgmt_m_KVMPassword, '6080',
                5500, frmDeviceMgmt_m_KVMRepeaterIP, frmDeviceMgmt_m_KVMRepeaterID);
    }
}

function frmVNCViewSend_Repeater()
{
    //    alert(frmVNCView_getRepeaterData())
    $global.Submit("/KVMMgmt", "post", frmVNCView_getRepeaterData(), m_user, m_password, frmVNCViewSend_RepeaterCallback);
}

function frmVNCView_getRepeaterData()
{
    var xml = "<request></request>";
    var xmlDoc = $.parseXML(xml);
    var itemNodeContent = '<item name="agentId" value="' + frmDeviceMgmt_m_AgentID + '"></item>';
    var itemNode = $.parseXML(itemNodeContent);
    $(xmlDoc).children(0).append($(itemNode).children(0));
    itemNodeContent = '<item name="mode" value="' + '3' + '"></item>';
    itemNode = $.parseXML(itemNodeContent);
    $(xmlDoc).children(0).append($(itemNode).children(0));
    itemNodeContent = '<item name="repeaterport" value="' + 5501 + '"></item>';
    itemNode = $.parseXML(itemNodeContent);
    $(xmlDoc).children(0).append($(itemNode).children(0));
    //    itemNodeContent = '<item name="repeaterhost" value="' + frmDeviceMgmt_m_KVMRepeaterIP + '"></item>';
    //    itemNode = $.parseXML(itemNodeContent);   
    //    $(xmlDoc).children(0).append($(itemNode).children(0));
    itemNodeContent = '<item name="repeaterid" value="' + frmDeviceMgmt_m_KVMRepeaterID + '"></item>';
    itemNode = $.parseXML(itemNodeContent);
    $(xmlDoc).children(0).append($(itemNode).children(0));
    //        alert($$.xmlToString(xmlDoc))
    return $$.xmlToString(xmlDoc);
}

function frmVNCViewSend_RepeaterCallback(xml_string) {
    frmDeviceMgmt_m_KVMIP = $(xml_string).find("IP").text();
    frmDeviceMgmt_m_KVMPort = $(xml_string).find("port").text();
    frmDeviceMgmt_m_KVMPassword = $(xml_string).find("password").text();
    frmDeviceMgmt_m_KVMRepeaterIP = location.toString().split(':')[1].replace(/\//g, '');
    frmDeviceMgmt_m_KVMMode = 3;
    VNCViewerInitialize(frmDeviceMgmt_m_KVMMode, frmDeviceMgmt_m_KVMIP, frmDeviceMgmt_m_KVMPassword, frmDeviceMgmt_m_KVMPort,
            5500, frmDeviceMgmt_m_KVMRepeaterIP, frmDeviceMgmt_m_KVMRepeaterID);
}
//Map Related 
function frmDeviceMgmt_MapFunction()
{
    $('.removeDeviceFromMap').live('click', function () {
        frmDeviceMgmt_MapItemDelete();
    });

    $('#frmDeviceMgmt_BtnTurnLeft').click(function () {
    });
    $('#frmDeviceMgmt_BtnTurnRight').click(function () {
    });
    $('#frmDeviceMgmt_BtnZoomIn').click(function () {
        var oMap = $('#frmDeviceMgmt_LocallMap').children(0);
        var oMapUL = frmDeviceMap_m_CurrentMap;
//        if (frmDeviceMap_m_CurrentMapNode.attr("ItemType") == "Device")
//            oMapUL = $('.MapList[AccountID="' + frmDeviceMap_m_CurrentMapNode.attr("AccountID") + '"][ItemValue="' + frmDeviceMap_m_CurrentMapNode.attr("ParentValue") + '"]');

        var nMapRatio = parseInt(oMapUL.attr("MapRatio")) + 10;
        if (nMapRatio <= 400)
        {
            frmDeviceMgmt_m_MapRatio = nMapRatio;
            oMapUL.attr("MapRatio", nMapRatio);
            oMap.css("width", nMapRatio + '%');
            oMap.css("height", nMapRatio + '%');
            oMap.css("left", (100 - nMapRatio) / 2 + '%');
            oMap.css("top", (100 - nMapRatio) / 2 + '%');
        }
    });
    $('#frmDeviceMgmt_BtnZoomOut').click(function () {
        var oMap = $('#frmDeviceMgmt_LocallMap').children(0);
        var oMapUL = frmDeviceMap_m_CurrentMap;
        var nMapRatio = parseInt(oMapUL.attr("MapRatio")) - 10;
        if (nMapRatio > 10)
        {
            frmDeviceMgmt_m_MapRatio = nMapRatio;
            oMapUL.attr("MapRatio", nMapRatio);
            oMap.css("width", nMapRatio + '%');
            oMap.css("height", nMapRatio + '%');
            oMap.css("left", (100 - nMapRatio) / 2 + '%');
            oMap.css("top", (100 - nMapRatio) / 2 + '%');
        }
    });
    //Add Device on Map or Layout
    $('#frmDeviceMgmt_MapAddDevice').click(function () {
        if (typeof frmDeviceUnAssignedList_initialize == 'undefined')
        {
            $('#index_pnlDeviceUnAssignedList').load('frmDeviceUnAssignedList.html?d=' + escape(Date()), function () {
                $('#index_pnlDeviceUnAssignedList').trigger('create');
                $global.faddingShow(true);
                frmDeviceUnAssignedList_initialize();
                $('#index_pnlDeviceUnAssignedList').show();
            })
        }
        else
        {
            $global.faddingShow(true);
            frmDeviceUnAssignedList_initialize();
            $('#index_pnlDeviceUnAssignedList').show();
        }
    });
    //Device info window
    $('.MapItem').live('click', function () {
        frmDeviceMap_m_CurrentMapNode.DeviceID = $(this).attr("ItemValue");
        frmDeviceMgmt_MapItemInfo();
    });

    //Relate to Event
    $('#frmDeviceMgmt_DeviceInfoEvent').live('click', function () {
        frmDeviceMgmt_SwitchToEvent($(this).attr('name'), $(this).attr('accountid'), $(this).attr('groupid'));
    });

    $('#frmInfoWindow_DeviceImg').live('click', function () {
        $('#index_MapPopupInfo').attr("ItemType", $(this).attr("AgentType"));
        $('#index_MapPopupInfo').attr("ItemValue", $(this).attr("AgentID"));
        $('#index_MapPopupInfo').attr("ItemName", $(this).attr("AgentName"));
        $('#index_MapPopupInfo').attr("ItemIcon", $(this).attr("AgentIcon"));
        
        switch($(this).attr("AgentType"))
        {
            case 'IPC':
            case 'IPC_IoTGW':
                $('#index_lstMapPopupInfo li[ItemValue="SWInfo"]').show();
                break;
            case 'SenHub':
                $('#index_lstMapPopupInfo li[ItemValue="SWInfo"]').hide();
                break;
        };
        frmDeviceMgmt_m_SelectAgentID = $(this).attr("AgentID");
        $('#index_MapPopupInfo').show();
        $('#index_MapPopupInfo').popup("open", {
            x: $(this).offset().left - 50,
            y: $(this).offset().top
        });
        frmInfoWindow_m_autoHide = false;
    });
}
function frmDeviceMgmt_SwitchToEvent(strName, strAccount, strGroup)
{
    m_Event_SearchText = strName;
    $('#index_modEvent').click();
    $('input[type="radio"]').checkboxradio("refresh");
    frmDeviceGroup_m_CurrentGroupNode.Panel = "Group";
    frmDeviceGroup_m_CurrentGroupNode.Direction = "right";
    frmDeviceGroup_m_CurrentGroupNode.ItemType = "Account";
    frmDeviceGroup_m_CurrentGroupNode.AccountID = strAccount;
    if (strGroup != "1")
    {
        frmDeviceGroup_m_CurrentGroupNode.ItemType = "Group";
        frmDeviceGroup_m_CurrentGroupNode.Panel = "Group";
        frmDeviceGroup_m_CurrentGroupNode.GroupID = strGroup;
    }
    $.cookie('selectedGroup31', JSON.stringify(frmDeviceGroup_m_CurrentGroupNode), {expires: myCookieExpiresDate});
}

function frmDeviceMgmt_MapItemSetLal(strAgentid, strMap, strLal)
{
    var xml = "<request></request>";
    var xmlDoc = $.parseXML(xml);

    var nodeParent = $.parseXML('<device/>');
    var nodeItem = null;
    nodeItem = $.parseXML('<item name="mapid" value="' + strMap + '"></item>');
    $(nodeParent).children(0).append($(nodeItem).children(0));
    nodeItem = $.parseXML('<item name="lal" value="' + strLal + '"></item>');
    $(nodeParent).children(0).append($(nodeItem).children(0));
    nodeItem = $.parseXML('<item name="map_action" value="update"></item>');
    $(nodeParent).children(0).append($(nodeItem).children(0));
    $(xmlDoc).children(0).append($(nodeParent).children(0));
    $global.Submit("/DeviceMgmt/" + strAgentid, "put", $$.xmlToString(xmlDoc), m_user, m_password, frmDeviceMgmt_MapItemSetLalCallback);
}
function frmDeviceMgmt_MapItemSetLalCallback(xmlResponse)
{
    if ($(xmlResponse).find('result').contents().empty().end().text() == "true")
    {
        if (frmDeviceMgmt_m_MapItemDroped != null)
        {
            var oMapUL = $('.MapList[ItemValue="' + frmDeviceMgmt_m_MapItemDroped.attr("ItemValue") + '"]');
            oMapUL.remove();
            frmDeviceMgmt_m_MapItemDroped.remove();
        }
        frmDeviceMap_m_CurrentMap.attr("LngLat", frmDeviceMap_m_CurrentMap.attr("LngLatTemp"));
        $$.LoadingMsg(false);
    }
    else
    {
        $$.MessageBox("error", $('#frmMessage_ModifyFailed').html());
        $$.LoadingMsg(false);
    }
}

function frmDeviceMgmt_MapItemDelete()
{
    $$.MessageDialog(frmMsgDialog_MsgType.normal, $('#frmDeviceMap_DelDeviceMsg').html(), frmMsgDialog_BtnType.OKCancel, frmDeviceMap_DelDevice_CallBack);
}
function frmDeviceMgmt_MapItemInfo()
{
    $global.Submit("/DeviceMgmt/" + frmDeviceMap_m_CurrentMapNode.DeviceID, "get", "", m_user, m_password, frmDeviceMgmt_MapItemInfoCallback);
}
function frmDeviceMgmt_MapItemInfoCallback(xmlResponse)
{
    var strStatus = $(xmlResponse).find("item").children("status").text();
    var strhwState = $(xmlResponse).find("item").children("hwState").text();
    var strhddState = $(xmlResponse).find("item").children("hddState").text();
    var strnetState = $(xmlResponse).find("item").children("netState").text();
    var strswState = $(xmlResponse).find("item").children("swState").text();
    var strAccountID = $(xmlResponse).find("item").find("accountid").text();
    var strGroupID = $(xmlResponse).find("item").find("groupid").text();
    var strHardwareStatus = '<a id="frmDeviceMgmt_DeviceInfoEvent" class="action-a" style="color: red; opacity: 1 !important;" accountid="' + strAccountID + '" groupid="' + strGroupID + '" name="' + $(xmlResponse).find("item").children("name").text() + '" title="' + $('#frmMessage_DeviceAbNormal').html() + '">' + $('#frmMessage_DeviceAbNormal').html() + '</a>';
    if (strStatus == "Connected")
    {
        if ((strhwState == "Normal") && (strhddState == "Normal") && (strnetState == "Normal"))
            strHardwareStatus = '<a style="color: #000; opacity: 1 !important;" title="' + $('#frmMessage_DeviceNormal').html() + '">' + $('#frmMessage_DeviceNormal').html() + '</a>';
    }
    else
        strHardwareStatus = '<a id="frmDeviceMgmt_DeviceInfoEvent" class="action-a" style="color: red; opacity: 1 !important;" accountid="' + strAccountID + '" groupid="' + strGroupID + '" name="' + $(xmlResponse).find("item").children("name").text() + '" title="' + $('#frmMessage_DeviceDisconnected').html() + '">' + $('#frmMessage_DeviceDisconnected').html() + '</a>';

    //Software Status
    var strSoftwareStatus = '<a id="frmDeviceMgmt_DeviceInfoEvent" class="action-a" style="color: red; opacity: 1 !important;" accountid="' + strAccountID + '" groupid="' + strGroupID + '" name="' + $(xmlResponse).find("item").children("name").text() + '" title="' + $('#frmMessage_DeviceAbNormal').html() + '">' + $('#frmMessage_DeviceAbNormal').html() + '</a>';
    if (strStatus == "Connected")
    {
        if (strswState == "Normal")
            strSoftwareStatus = '<a style="color: #000; opacity: 1 !important;" title="' + $('#frmMessage_DeviceNormal').html() + '">' + $('#frmMessage_DeviceNormal').html() + '</a>';
    }
    else
        strSoftwareStatus = '<a id="frmDeviceMgmt_DeviceInfoEvent" class="action-a" style="color: red; opacity: 1 !important;" accountid="' + strAccountID + '" groupid="' + strGroupID + '" name="' + $(xmlResponse).find("item").children("name").text() + '" title="' + $('#frmMessage_DeviceDisconnected').html() + '">' + $('#frmMessage_DeviceDisconnected').html() + '</a>';

    var strContent = '<div style="background-color: white; overflow: auto; display: block; width:300px;">';
    var strIcon = $(xmlResponse).find("item").find("icon").text();
    if (strIcon.toLowerCase() == "default")
        strIcon = "Device1.png";
    if (strStatus == "Disconnected")
        strContent = strContent + '<img id="frmInfoWindow_DeviceImg" class="ui-disabled" disabled="disabled" border="0" align="left" src="images/eMap/' + strIcon + '" style="width: 64px; height: 64px;">';
    else
        strContent = strContent + '<img id="frmInfoWindow_DeviceImg" class="action-img2" border="0" align="left" src="images/eMap/' + strIcon + '" style="width: 64px; height: 64px; cursor: pointer" AgentType="' + $(xmlResponse).find("item").children("agentType").text() + '" AgentID="' + $(xmlResponse).find("item").children("agentId").text() + '" AgentName="' + $(xmlResponse).find("item").children("name").text() + '" AgentIcon="' + strIcon + '")>';
    strContent = strContent + '<table style="margin-top: 10px; margin-left: 64px; background-color: white; max-width:300px; table-layout:fixed;">';
    strContent = strContent + '<tr>';
    strContent = strContent + '<td style="white-space:pre;">' + $('#frmDeviceMgmt_DeviceHeader').find('th').eq(1).find('a').html() + ' : </td>';
    strContent = strContent + '<td style="white-space:pre; text-wrap:normal; word- break:break-all"><a>' + $(xmlResponse).find("item").children("name").text() + '</a></td>';
    strContent = strContent + '</tr>';
    strContent = strContent + '<tr>';
    strContent = strContent + '<td style="white-space:pre;">' + $('#frmDeviceMgmt_DeviceHeader').find('th').eq(2).find('a').html() + ' : </td>';
    strContent = strContent + '<td style="white-space:pre; text-wrap:normal; word- break:break-all"><a>' + strHardwareStatus + '</a></td>';
    strContent = strContent + '</tr>';
    switch($(xmlResponse).find("item").children("agentType").text())
    {
        case 'IPC':
        case 'IPC_IoTGW':
            strContent = strContent + '<tr>';
            strContent = strContent + '<td style="white-space:pre;">' + $('#frmDeviceMgmt_DeviceHeader').find('th').eq(3).find('a').html() + ' : </td>';
            strContent = strContent + '<td style="white-space:pre; text-wrap:normal; word- break:break-all"><a>' + strSoftwareStatus + '</a></td>';
            strContent = strContent + '</tr>';
            break;
        case 'SenHub':
            break;
    };
    strContent = strContent + '<tr>';
    strContent = strContent + '<td style="white-space:pre;"><img class="removeDeviceFromMap" src="images/ico_delete.png" style="width: 24px; height: 24px; cursor: pointer;"></td>';
    strContent = strContent + '<td></td>';
    strContent = strContent + '</tr>';
    strContent = strContent + '</table>';
    //    strContent = strContent + '<a id="frmDeviceList_DeviceInfoEvent" class="clickAbleLabel" style="color: blue;" name="' + $(xmlResponse).find("item").find("name").text() + '">' + $('#frmDeviceMgmt_msgEventDetail').html() + '</a>';

    frmInfoWindow_SetContent(strContent);

    var oMapItem = $('.MapItem[ItemValue="' + frmDeviceMap_m_CurrentMapNode.DeviceID + '"]');
    var nLeft = oMapItem.offset().left - $("#index_pnlDeviceInfoWindow").width() / 2 + oMapItem.width() / 2;
    var nTop = oMapItem.offset().top - $("#index_pnlDeviceInfoWindow").height();
    var nWidth = $("#index_pnlDeviceInfoWindow").width();
    $('#index_pnlDeviceInfoWindow').show();
    $("#index_pnlDeviceInfoWindow").css({
        left: nLeft,
        top: nTop
    });
    $("#index_pnlDeviceInfoWindow").width(nWidth);
}

function frmDeviceMgmt_MapAddLayoutFromMarker(strMapID)
{
//    frmDeviceMap_SetMode(frmDeviceMap_m_EnumMode.Map);
//    frmDeviceMap_m_CurrentMapNode = $('.MapList[ItemValue="' + strMapID + '"]');
//    $('#frmDeviceMap_BtnAddLayout').click();
}
function frmDeviceMgmt_MapAddDeviceFromMarker(strMapID)
{
//    frmDeviceMap_SetMode(frmDeviceMap_m_EnumMode.LocalMap);
//    frmDeviceMap_m_CurrentMapNode = $('.MapList[ItemValue="' + strMapID + '"]');
//    $('#frmDeviceMgmt_MapAddDevice').click();
}
function frmDeviceMgmt_DeviceBasicEdit(strItemValue, bEditable)
{
    frmDeviceMgmt_log.info('call frmDeviceMgmt_DeviceBasicEdit func: ' + strItemValue);

    frmDeviceMgmt_m_SelectAgentID = strItemValue;
    frmDeviceMgmt_log.debug('frmDeviceMgmt_m_SelectAgentID: ' + frmDeviceMgmt_m_SelectAgentID);
    if (typeof frmDeviceEdit_initialize == 'undefined')
    {
        frmDeviceMgmt_log.debug('device edit (A)');
        $('#index_pnlDeviceEdit').load('page_module/DeviceMgmt/frmDeviceEdit.html?d=' + escape(Date()), function () {

            frmDeviceMgmt_log.debug('device edit (A) loaded');

            //wordaround 2015/03/16
            //added by ken 
            //避免從IoTGW點擊device info，frmDeviceMgmt_m_SelectAgentID消失的議題
            frmDeviceMgmt_m_SelectAgentID = strItemValue;

            $('#index_pnlDeviceEdit').trigger('create');

            $global.faddingShow(true);
            //modified by ken 2015/09/09
            frmDeviceEdit_initialize(false, bEditable, function () {
                frmDeviceMgmt_log.debug('frmDeviceEdit_initialize callback (A)');
//                $('#index_pnlDeviceEdit').fadeIn();
            });


//            setTimeout(function () {
//                frmDeviceEdit_initialize(false, bEditable);
//                $('#index_pnlDeviceEdit').fadeIn();
//            }, 100);
        });
    }
    else
    {
        frmDeviceMgmt_log.debug('device edit (B)');

        $global.faddingShow(true);
        //modified by ken 2015/09/09
        frmDeviceEdit_initialize(false, bEditable, function () {
            frmDeviceMgmt_log.debug('frmDeviceEdit_initialize callback (B)');
//            $('#index_pnlDeviceEdit').fadeIn();
        });

//        setTimeout(function () {
//            frmDeviceEdit_initialize(false, bEditable);
//            $('#index_pnlDeviceEdit').fadeIn();
//        }, 100);
    }
}
function frmDeviceMgmt_DeviceBasicInfo(strItemValue)
{
    frmDeviceMgmt_m_SelectAgentID = strItemValue;
    if (typeof frmDeviceViewDetail_initialize == 'undefined')
    {
        $('#index_pnlDeviceDetail').load('frmDeviceViewDetail.html?d=' + escape(Date()), function () {
            $('#index_pnlDeviceDetail').trigger('create');
            $global.faddingShow(true);
            setTimeout(function () {
                frmDeviceViewDetail_initialize();
                $('#index_pnlDeviceDetail').fadeIn();
            }, 100);
        });
    }
    else
    {
        $global.faddingShow(true);
        setTimeout(function () {
            frmDeviceViewDetail_initialize();
            $('#index_pnlDeviceDetail').fadeIn();
        }, 100);
    }
}
function frmDeviceMgmt_DeviceHWInfo(strType, strID, strName, strConnected, strDafaultTab)
{
    switch(strType)
    {
        case 'device':
        case 'Device':
        case 'IPC':
        case 'IPC_IoTGW':
            if (typeof frmDeviceMgmtHWInfo_initialize == 'undefined')
            {
                $('#index_pnlDeviceMgmtHWInfo').load('frmDeviceMgmtHWInfo.html?d=' + escape(Date()), function () {
                    $('#index_pnlDeviceMgmtHWInfo').trigger('create');
                    $global.faddingShow(true);
                    frmDeviceMgmtHWInfo_initialize(strType, strID, strName, strConnected, strDafaultTab);
                });
            }
            else
            {
                $global.faddingShow(true);
                frmDeviceMgmtHWInfo_initialize(strType, strID, strName, strConnected, strDafaultTab);
            }
            break;
        case 'SenHub':
            if (typeof (frmDevsenNodeDataiceMgmtIoTGwSensorInfo_m_Request) == 'undefined')
            {
                $('#index_pnlDeviceMgmtIoTGwSensorInfo').load('page_module/DeviceMgmt/frmDeviceMgmtIoTGwSensorInfo.html?d=' + escape(Date()), function () {
                    $('#index_pnlDeviceMgmtIoTGwSensorInfo').trigger('create');
                    $global.faddingShow(true);
                    $('#index_pnlDeviceMgmtIoTGwSensorInfo').show();
                    frmDeviceMgmtIoTGwSensorInfo_initialize(false, strID, strName);
                });
            }
            else
            {
                $global.faddingShow(true);
                $('#index_pnlDeviceMgmtIoTGwSensorInfo').show();
                frmDeviceMgmtIoTGwSensorInfo_initialize(true, strID, strName);
            }
            break;
    };
}
function frmDeviceMgmt_DeviceSWInfo(strType, strID, strName, strConnected)
{
    if (typeof frmDeviceMgmtSWInfo_initialize == 'undefined')
    {
        $('#index_pnlDeviceMgmtSWInfo').load('frmDeviceMgmtSWInfo.html?d=' + escape(Date()), function () {
            $('#index_pnlDeviceMgmtSWInfo').trigger('create');
            $global.faddingShow(true);
            frmDeviceMgmtSWInfo_initialize(strType, strID, strName, strConnected);
        });
    }
    else
    {
        $global.faddingShow(true);
        frmDeviceMgmtSWInfo_initialize(strType, strID, strName, strConnected);
    }
}

//Modify Device administrator
function frmDeviceMgmt_SelectAccount(strID, strName)
{
    $('#index_pnlDeviceSelectAdministrator').hide();
    $global.faddingShow(false);
    if (strID != null)
    {
        //        frmDeviceMgmt_m_CurrentDevice.find("td").eq(5).find('.ViewMode').html(strName);
        //        frmDeviceMgmt_m_CurrentDevice.find("td").eq(5).attr('selectName' , strName);
        frmDeviceMgmt_EditAccount(strID);
    }
}
function frmDeviceMgmt_EditAccount(strAccount)
{
    $$.LoadingMsg(true);
    var xml = "<request></request>";
    var xmlDoc = $.parseXML(xml);
    var nodeParent = $.parseXML('<device/>');
    var nodeItem = $.parseXML('<item name="accountid" value="' + strAccount + '"></item>');
    $(nodeParent).children(0).append($(nodeItem).children(0));
    nodeItem = $.parseXML('<item name="groupid" value="1"></item>');
    $(nodeParent).children(0).append($(nodeItem).children(0));
    nodeItem = $.parseXML('<item name="mapid" value="1"></item>');
    $(nodeParent).children(0).append($(nodeItem).children(0));
    $(xmlDoc).children(0).append($(nodeParent).children(0));
    $global.Submit("/DeviceMgmt/" + frmDeviceMgmt_m_SelectAgentID, "put", $$.xmlToString(xmlDoc), m_user, m_password, frmDeviceMgmt_EditAccountCallback);
}
function frmDeviceMgmt_EditAccountCallback(xmlResponse)
{
    if ($(xmlResponse).find('result').text() == "true")
    {
        frmDeviceGroup_LoadAccountAndGroup();
        $$.LoadingMsg(false);
    }
    else
    {
        $$.MessageBox("error", $('#frmMessage_ModifyFailed').html());
    }
}

function frmDeviceMgmt_SortOperation()
{
    frmDeviceMgmt_log.info('call frmDeviceMgmt_SortOperation func');
    frmDeviceMgmt_log.info('call sort field event-binding');

    $('#frmDeviceMgmt_DeviceHeader th').click(function (event) {
        frmDeviceMgmt_log.debug('click sort header of device list');
        var $thOfHeader = $(this);
        var sortType = $thOfHeader.attr('colval');
        frmDeviceMgmt_log.debug('click sort header of device list: ' + sortType);

        if ($(this).attr('disabled'))
            return;

        if (typeof $(this).attr('colval') == 'undefined')
            return;

        //added by ken 2015/05/15
        if (sortType == 'hwstate' || sortType == 'swstate' || sortType == 'reportstate') {
            frmDeviceMgmt_log.warn('cannot sory by: ' + sortType);
            return;
        }

        $$.LoadingMsg(true);
        $('#frmDeviceMgmt_DeviceHeader th').find('.DESC').hide();
        $('#frmDeviceMgmt_DeviceHeader th').find('.ASC').hide();

        if ($(this).attr('currentSort') == 'ASC')
        {
            $(this).find('.DESC').hide();
            $(this).find('.ASC').show();
            $(this).attr('currentSort', 'DESC');
            frmDeviceMgmt_m_SortType = 'DESC';
        }
        else
        {
            $(this).find('.DESC').show();
            $(this).find('.ASC').hide();
            $(this).attr('currentSort', 'ASC');
            frmDeviceMgmt_m_SortType = 'ASC';
        }


        frmDeviceMgmt_m_SortBy = $(this).attr('colval');
        frmDeviceMgmt_m_CurrentPage = 1;

        frmDeviceMgmt_log.debug('device mgmt on LIST sort by :' + frmDeviceMgmt_m_SortBy + ' , ' + frmDeviceMgmt_m_SortType);

        frmDeviceMgmt_DeviceFuzzySearch();
    });

    $('#frmDeviceMgmt_GroupHeader th').click(function () {
        if ($(this).attr('disabled'))
            return;

        if (typeof $(this).attr('colval') == 'undefined')
            return;

        $$.LoadingMsg(true);
        $('#frmDeviceMgmt_GroupHeader th').find('.DESC').hide();
        $('#frmDeviceMgmt_GroupHeader th').find('.ASC').hide();

        if ($(this).attr('currentSort') == 'ASC')
        {
            $(this).find('.DESC').hide();
            $(this).find('.ASC').show();
            $(this).attr('currentSort', 'DESC');
            frmDeviceMgmt_m_SortType = 'DESC';
        }
        else
        {
            $(this).find('.DESC').show();
            $(this).find('.ASC').hide();
            $(this).attr('currentSort', 'ASC');
            frmDeviceMgmt_m_SortType = 'ASC';
        }
        frmDeviceMgmt_m_SortBy = $(this).attr('colval');
        frmDeviceMgmt_m_CurrentPage = 1;

        frmDeviceMgmt_log.debug('device mgmt on GROUP sort by :' + frmDeviceMgmt_m_SortBy + ' , ' + frmDeviceMgmt_m_SortType);

        frmDeviceMgmt_DeviceFuzzySearch();
    });
}

function frmDeviceMgmt_ClearTable()
{
    frmDeviceMgmt_log.info('call frmDeviceMgmt_ClearTable func');
    //    $('#frmDeviceMgmt_DeviceBody tr').has('td').remove();
    $('#frmDeviceMgmt_DeviceBody tr').remove();//added by ken 20140922
    $('#frmDeviceMgmt_GroupBody tr').remove();
    $('#frmDeviceMgmt_PageIndecator').html("0 / 0");
    $('#frmDeviceMgmt_selectPage').find('option').remove();
    $('#frmDeviceMgmt_selectPage').append('<option value=0>0</option>');
    $("#frmDeviceMgmt_selectPage").selectmenu('refresh', true);
    frmDeviceMgmt_log.debug('remove all rows from device mgnt');
}

function frmDeviceMgmt_setIconStatus(isShowItem)
{
    if ($('#frmDeviceMgmt_Print').attr('needDetectShow') == 'false')
    {
        $('#frmDeviceMgmt_Print').addClass('ui-disabled');
        $('#frmDeviceMgmt_Print').attr('disabled', 'disabled');
    }
    else
    {
        if (isShowItem)
        {
            $('#frmDeviceMgmt_Print').removeClass('ui-disabled');
            $('#frmDeviceMgmt_Print').removeAttr('disabled');
        }
        else
        {
            $('#frmDeviceMgmt_Print').addClass('ui-disabled');
            $('#frmDeviceMgmt_Print').attr('disabled', 'disabled');
        }
    }
}


function frmDeviceMgmt_setIconDisableDirect(isShowItem)
{
    $('#frmDeviceMgmt_Print').attr('needDetectShow', isShowItem);
    if (!isShowItem)
    {
        $('#frmDeviceMgmt_Print').addClass('ui-disabled');
        $('#frmDeviceMgmt_Print').attr('disabled', 'disabled');
    }
}



//added by ken 2015/03/04
function frmDeviceMgmt_buildSensorTreegird($sensorTable, dataSet) {
    frmDeviceMgmt_log.info('call frmDeviceMgmt_buildSensorTreegird func');
    var sensorElems = '';//treegird elements   
    var $tbodyOfSensorTable = $sensorTable.find('tbody');
    var isEnd = false;
    for (var i = 0; i < dataSet.length; i++) {
        var tmpSensor = dataSet[i];
        frmDeviceMgmt_log.debug(tmpSensor);
        //store data
        $sensorTable.data(tmpSensor.id, tmpSensor);
        if (i == (dataSet.length - 1)) {
            isEnd = true;
        }
        sensorElems += frmDeviceMgmt_appendSensorTreegirdElem(tmpSensor, isEnd);
    }

    $tbodyOfSensorTable.append(sensorElems);

    //action bind
    $sensorTable.find('.device-tree-sensor-node-name').click(function () {
        frmDeviceMgmt_log.debug('open sensor monitor from SenNode');

        //當前點擊的tr
        var $parentTr = $(this).parent().parent();

        //取得device id那一列的tr
        var $preParentTr = $parentTr.parent().parent().parent().parent().prev();

        //get device data
        var preParentDeviceId = $preParentTr.attr('data-device-id');
        frmDeviceMgmt_log.debug('device id: ' + preParentDeviceId);
        var deviceData = $('#frmDeviceMgmt_DeviceBody').data(preParentDeviceId);
        frmDeviceMgmt_log.debug(deviceData);

        //get sensor data
        var sensorPathId = $parentTr.attr('data-sensor-id');
        var sensorData = $sensorTable.data(sensorPathId);
        frmDeviceMgmt_log.debug(sensorData);

        var $tdAgentReport = $preParentTr.find('td.dev-cell-report');
        var autoReport = $tdAgentReport.find('a').attr('data-report');
        //            $(deviceData).find('autoReport').text().toLowerCase();
        frmDeviceMgmt_log.debug('open info spec dialog: ' + autoReport);
        if (autoReport == 'enable') {
            frmDeviceMgmt_OpenIoTGwSensorInfo(deviceData, sensorData);
        } else {
            frmDeviceMgmt_log.warn('plenase enable agent report on SenNode');
            $$.MessageBox('info', 'Please enable agent report');
        }

    });
}
function frmDeviceMgmt_appendSensorTreegirdElem(sensor, isEnd) {
    frmDeviceMgmt_log.info('call frmDeviceMgmt_appendSensorTreegirdElem func');
    var sensorElems;
    var sensorTreeIcon;
    //{     n: mcu temp,
    //  id: /SenData/mcu temp,
    //  v: 0,
    //  vtype: value,
    //  min: 0,
    //  max: 100,
    //  type: d
    //}
    sensorElems = '<tr data-sensor-id="' + sensor.id + '" class="treegridparent" >';
    //sensor name
    if (isEnd) {
        sensorTreeIcon = 'device-tree-node-end';
    } else {
        sensorTreeIcon = 'device-tree-node-start';
    }
    sensorElems += '<td class="' + sensorTreeIcon + '"><a class="device-tree-sensor-node-name action-a ui-link"><img src="images/icons/icons-sensor.png" />' + sensor.n + '</a></td>';

    //sensor type
    //    sensorElems += '<td>' + sensor.type + '</td>';

    //sensor unit
    sensorElems += '<td>' + sensor.unit + '</td>';

    //sensor min
    sensorElems += '<td>' + sensor.min + '</td>';

    //sensor max
    sensorElems += '<td>' + sensor.max + '</td>';

    sensorElems += '</tr>';
    
    return sensorElems;
}

function frmDeviceMgmt_buildDeviceInfoSpecTreegird($sensorTable, dataSet) {
    frmDeviceMgmt_log.info('call frmDeviceMgmt_buildTreegird func');
    var $tbodyOfSensorTable = $sensorTable.find('tbody');
    var sensorElems = '';//treegird elements   
    var treegirdid = 0;
    var treegirdPid = 0;
    for (var i = 0; i < dataSet.length; i++) {
        var tmpSensor = dataSet[i];
        //        frmDeviceMgmt_log.debug(tmpSensor);               
        /*
         {
         n: dir,
         id: /GPIO/GPIO04/dir,
         v: 0,
         vtype: value
         }
         */
        //store sensor data
        $sensorTable.data(tmpSensor.id, tmpSensor);
        var lastN = '/' + tmpSensor.n;
        frmDeviceMgmt_log.debug('full id: ' + tmpSensor.id);
        frmDeviceMgmt_log.debug('lastN: ' + lastN);
        var bnWithoutN = tmpSensor.id.replace(lastN, '');
        frmDeviceMgmt_log.debug('bnWithoutN: ' + bnWithoutN);
        var parseBnArr = bnWithoutN.split(/\b\/+/g);
        frmDeviceMgmt_log.debug(parseBnArr);
        var deviceLv2 = parseBnArr[parseBnArr.length - 1];//get last Bn(用來注入第二層)
        frmDeviceMgmt_log.debug('device lv2: ' + deviceLv2);

        var displayNodeName;
        var checkParentNodeId_PidWithoutN = $sensorTable.data(bnWithoutN);
        frmDeviceMgmt_log.debug('current path id(without n): ' + bnWithoutN + ', key: ' + deviceLv2 + ', parent id: ' + checkParentNodeId_PidWithoutN);

        if (typeof (checkParentNodeId_PidWithoutN) != 'undefined') {

            frmDeviceMgmt_log.debug('Find Old Row, path id: ' + bnWithoutN + ', key: ' + deviceLv2 + ', parent id: ' + checkParentNodeId_PidWithoutN);

            sensorElems +=
                    frmDeviceMgmt_appendSensorNodeTreegirdElem(
                            tmpSensor.id,
                            treegirdid,
                            checkParentNodeId_PidWithoutN, //parent id
                            tmpSensor.n,
                            bnWithoutN,
                            tmpSensor.v);

        } else {

            frmDeviceMgmt_log.debug('New Row, path id: ' + bnWithoutN + ', key: ' + deviceLv2 + ', parent id: ' + checkParentNodeId_PidWithoutN);

            //
            //fake parent node
            //
            sensorElems +=
                    frmDeviceMgmt_appendSensorNodeTreegirdElem(
                            bnWithoutN,
                            treegirdid,
                            null,
                            deviceLv2,
                            'Root',
                            '-');


            treegirdPid = treegirdid;

            //very important!! for match parent node
            $sensorTable.data(bnWithoutN, treegirdPid);


            frmDeviceMgmt_log.debug('new pid: ' + treegirdPid);

            //
            //current node
            //
            treegirdid++; //after parent treegrid id

            sensorElems +=
                    frmDeviceMgmt_appendSensorNodeTreegirdElem(
                            tmpSensor.id,
                            treegirdid,
                            treegirdPid,
                            tmpSensor.n,
                            bnWithoutN,
                            tmpSensor.v);


        }
        frmDeviceMgmt_log.debug('-finish node-');
        // store full info
        $sensorTable.data(tmpSensor.id, tmpSensor);

        treegirdid++;//next treegrid Id
    }//end of for


    //append to table
    $tbodyOfSensorTable.append(sensorElems);
    $sensorTable.treegrid({
        //                            treeColumn: 1
    });

    //action binding
    //                        alert(  $sensorTable.find('.treegrid-child-name').length);
    $sensorTable.find('.treegrid-child-name').click(function () {


        //當前點擊的tr
        var $parentTr = $(this).parent().parent();

        //取得device id那一列的tr
        var $preParentTr = $parentTr.parent().parent().parent().parent().prev();
        var preParentDeviceId = $preParentTr.attr('data-device-id');
        frmDeviceMgmt_log.debug('device id: ' + preParentDeviceId);
        var deviceData = $('#frmDeviceMgmt_DeviceBody').data(preParentDeviceId);
        //                             frmDeviceMgmt_log.debug(deviceData);

        var sensorPathId = $parentTr.attr('data-sensor-path-sid');//path child id
        frmDeviceMgmt_log.debug('click child name: ' + sensorPathId);
        var sensorNodeData = $sensorTable.data(sensorPathId);
        frmDeviceMgmt_log.debug(sensorNodeData);

        //
        //open info spec dialog
        //
        frmDeviceMgmt_log.debug('open info spec dialog');
        frmDeviceMgmt_OpenIoTGwSensorInfo(deviceData);
    });
}

function frmDeviceMgmt_buildSenNodeTreegirdElem($sensorTable, dataSet) {
    frmDeviceMgmt_log.info('call frmDeviceMgmt_buildSenNodeTreegirdElem func');
    var $tbodyOfSensorTable = $sensorTable.find('tbody');

    var countOfSenNode = dataSet.length;
    var isEnd = false;
    var sensorElems = '';
    $.each(dataSet, function (i, obj) {
        var $itemOfSenNode = $(obj);
        if (i == (countOfSenNode - 1)) {
            isEnd = true;
        }
        var agentId = $itemOfSenNode.find('agentId').text();
        if (typeof (agentId) == 'undefined') {
            frmDeviceMgmt_log.error('cannot find agentId');
        } else {
            $sensorTable.data(agentId, $itemOfSenNode);
            sensorElems += frmDeviceMgmt_appendSenNodeTreegirdElem($itemOfSenNode, isEnd);
        }

    });
    $tbodyOfSensorTable.append(sensorElems);

    //bind open device action
    $tbodyOfSensorTable.find('.device-tree-sennode-name').click(function () {
        try
        {
            event.stopPropagation();
        }
        catch(e){}
        var $tr = $(this).parent().parent();
        frmDeviceMgmt_log.debug('click sensnode name from SenNode');
        var agentId = $tr.attr('data-sensor-id');
        frmDeviceMgmt_log.debug('SenNode: ' + agentId);
        frmDeviceMgmt_m_SelectAgentID = agentId;
        frmDeviceMgmt_DeviceBasicEdit(agentId, false);
    });

    $tbodyOfSensorTable.find('.device-tree-sennode-hwstatus').click(function () {
        var $tr = $(this).parent().parent();
        frmDeviceMgmt_log.debug('click sensnode hwstatus from SenNode');

        var agentId = $tr.attr('data-sensor-id');
        frmDeviceMgmt_log.debug('SenNode: ' + agentId);
        //在SenNode下的device為一個Sensor
        var $deviceData = $sensorTable.data(agentId);
        var hwStatus = $deviceData.find('status').text();

        var $reportStatus = $tr.find('a.device-tree-sennode-autoreport');
        var autoReport = $reportStatus.attr('data-report');

        //20150626目前senhub尚未支援agent report的動作，先註解
        frmDeviceMgmt_OpenIoTGwSensorInfo($deviceData);
    });//end of hwstatus

    $tbodyOfSensorTable.find('.device-tree-sennode-autoreport').click(function () {
        frmDeviceMgmt_log.debug('click sensnode autoreport from SenNode');

        var $currStatus = $(this);

        var reportStatus = $currStatus.attr('data-report');

        frmDeviceMgmt_log.debug("click report status (Level 2): " + reportStatus);

        var $tr = $currStatus.parent().parent();

        var agentId = $tr.attr('data-sensor-id');
        frmDeviceMgmt_log.debug('SenNode: ' + agentId);
        var $deviceData = $sensorTable.data(agentId);

        var agentName = $deviceData.find('name').text();
        var agentType = 'device';//refer to $tr itemvalue

        frmDeviceMgmt_OpenAgentReport(agentId, agentName, agentType, reportStatus, $currStatus)

    });//end of  autoreport
}
function frmDeviceMgmt_appendSenNodeTreegirdElem(senNode, isEnd) {
    frmDeviceMgmt_log.info('call frmDeviceMgmt_appendSenNodeTreegirdElem func');

    var sensorElems;
    var sensorTreeIcon;

    //   <sensorInterface>/WSN/0000852CF4B7B0E8/Info/SenNodeList</sensorInterface>
    //                <did>4</did>
    //                <agentId>0000000EC6F0F831</agentId>
    //                <name>WISE1020</name>
    //                <status>Connected</status>
    //                <maintime>2015-03-10 14:38:38.209</maintime>
    //                <mainstate>1</mainstate>
    //                <upgrade>false</upgrade>
    //                <hwstate>HW_Status_Normal</hwstate>
    //                <swstate>SW_Status_Normal</swstate>
    //                <autoReport>true</autoReport>
    //                <reportInterval>2147483647</reportInterval>
    //                <agentType>SenNode</agentType>

    //    sensorElems = '<tr data-sensor-id="'+ senNode.id + '" class="treegridparent" >';
    //    
    sensorElems = '<tr data-sensor-id="' + senNode.find('agentId').text() + '" class="treegridparent" >';
    //sensor name
    if (isEnd) {
        sensorTreeIcon = 'device-tree-node-end';
    } else {
        sensorTreeIcon = 'device-tree-node-start';
    }
//    var statusIcon = '<img src="images/icons/icons-sensor-node-on.png" class="device-tree-sennode-status">';
//    if (senNode.find('status').text() != 'Connected') {
//        statusIcon = '<img src="images/icons/icons-sensor-node-off.png" class="device-tree-sennode-status">';
//    }

    var statusIcon = 'device-tree-sennode-name-connected';
    var elemHwStatus = '';
    var hwStatusIcon = 'images/ico_HardWare.png';

    var i18nDeviceNormal = $('#frmMessage_DeviceNormal').html();
    var i18DeviceAbnormal = $('#frmMessage_DeviceAbNormal').html();
    var hwstatus = i18nDeviceNormal;

    //Normal
//    alert('hw status:  ' + senNode.find('hwState').text() );
    if (senNode.find('hwState').text() != 'Normal') {
        
        hwstatus = i18DeviceAbnormal;
//        hwStatusIcon = 'images/ico_HardWareE.png';
    }else{
        hwstatus = i18nDeviceNormal;
        
    }
    if (senNode.find('status').text() != 'Connected') {
        statusIcon = 'device-tree-sennode-name-disconnected';
        elemHwStatus = '<td><a class="device-tree-sennode-hwstatus action-a ui-link" style="color: #000; opacity: 1 !important;" title="' + hwstatus + '" ><img style="width: 24px; height: 24px;"  src="' + hwStatusIcon + '" disabled="disabled" class="ui-disabled"/></a></td>';
    } else {
        elemHwStatus = '<td><a class="device-tree-sennode-hwstatus action-a ui-link" style="color: #000; opacity: 1 !important;" title="' + hwstatus + '" ><img style="width: 24px; height: 24px;"  src="' + hwStatusIcon + '" /></a></td>';
    }



    //    sensorElems += '<td class="' + sensorTreeIcon + '"><a class="device-tree-sennode-name action-a ui-link" >' + senNode.sv + '</a></td>';
    sensorElems += '<td class="' + sensorTreeIcon + '">' + '<a class="device-tree-sennode-name action-a ui-link ' + statusIcon + '" title="' + senNode.find('name').text() + '" >' + senNode.find('name').text() + '</a></td>';

    //modified by ken 2015/08/24
    //stop to display agent type
//    sensorElems += '<td><span title="' + senNode.find('agentType').text() + '">' + senNode.find('agentType').text() + '</span></td>';

    sensorElems += elemHwStatus;

    var i18nDeviceReportEnable = $('#frmDeviceMgmt_txtDeviceReportEnable').html();
    var i18nDeviceReportDisable = $('#frmDeviceMgmt_txtDeviceReportDisable').html();
    var reportStatus = senNode.find("autoReport").text().toLowerCase();
    frmDeviceMgmt_log.debug('reportStatus: ' + reportStatus);

    if (reportStatus == 'true') {

        if ($.inArray("a", privilege_array) > -1) {
            reportStatus = '<a class="device-tree-sennode-autoreport action-a" style="color:  #000; opacity: 1 !important;" title="' + i18nDeviceReportEnable + '" data-report="enable"><img src="images/autoreport_on.png" /></a>';
        } else {

            reportStatus = '<a class="device-tree-sennode-autoreport action-a" style="color:  #000; opacity: 1 !important;" title="' + i18nDeviceReportEnable + '" data-report="enable" ><img src="images/autoreport_on.png" disabled="disabled"/></a>';
        }
    } else {
        reportStatus = '<a class="device-tree-sennode-autoreport action-a" style="color:  #000; opacity: 1 !important;" title="' + i18nDeviceReportEnable + '" data-report="disable"><img src="images/autoreport_off.png" /></a>';
    }

//    sensorElems += '<td >' + reportStatus + '</td>';

    sensorElems += '<td>' + senNode.find('sensorHubInterface').text().replace(SA3.device.SenNodeList, '') + '</td>';

//    sensorElems += '<td >' + senNode.find('agentId').text() + '</td>';
    //    sensorElems +=  '<td >' + senNode.sensorId.replace('/Info/SenNodeList', '')+ '</td>';

    //    sensorElems +=  '<td >' +  easydate.date2Str(new Date(senNode.ts)) + '</td>';

    sensorElems += '<tr/>';
    return sensorElems;
}

//function frmDeviceMgmt_buildSenNodeTreegirdElem($sensorTable,dataSet){
//      
//    frmDeviceMgmt_log.info('call frmDeviceMgmt_buildSenNodeTreegirdElem func');
//    
//    var $tbodyOfSensorTable =  $sensorTable.find('tbody');
//    var sensorElems = '';//treegird elements  
//    var isEnd = false;
//    for(var i=0;i<dataSet.length;i++){
//        var senNode = dataSet[i]; 
//        //store data
//        $sensorTable.data(i.toString(),senNode);
//        
//        if(i==(dataSet.length-1)){
//            isEnd = true;
//        }
//        
//        if(senNode.sv.indexOf(',') >= 0){
//            frmDeviceMgmt_log.warn('detect multi SenNode in ONE interface');
//            
//            /**
//             * //Multiple SenNode in ONE Interface
//             **/
//            var senNodeOfInterFaceArr = senNode.sv.split(',');
//            var lenOfSenNodeOfInterFaceArr = senNodeOfInterFaceArr.length;
//            var isEndLevel2 = false;
//            var useEndLevel2Check = false;
//            if(dataSet.length == 1){
//                useEndLevel2Check = true;
//            }
//            frmDeviceMgmt_log.warn('useEndLevel2Check: ' + useEndLevel2Check);
//            
//            for(var iSenNodeOfInterFace = 0; iSenNodeOfInterFace<lenOfSenNodeOfInterFaceArr; iSenNodeOfInterFace++){
//                var currSenNode = senNodeOfInterFaceArr[iSenNodeOfInterFace];
//                var newSenNode = {
//                    ts: senNode.ts,
//                    sensorId: senNode.sensorId,
//                    sv: currSenNode
//                };
//                if(useEndLevel2Check){
//                    if(iSenNodeOfInterFace==(lenOfSenNodeOfInterFaceArr-1)){
//                        isEndLevel2 = true;
//                    }
//                    sensorElems+= frmDeviceMgmt_appendSenNodeTreegirdElem(newSenNode,isEndLevel2);
//                }else{
//                    sensorElems+= frmDeviceMgmt_appendSenNodeTreegirdElem(newSenNode,isEnd);
//                }
//                   
//                
//            }//end of senNodeOfInterFaceArr
//            
//        }else{
//            sensorElems+= frmDeviceMgmt_appendSenNodeTreegirdElem(senNode,isEnd);
//        }    
//    }
//    $tbodyOfSensorTable.append(sensorElems);
//    
//    //bind open device action
//    $tbodyOfSensorTable.find('.device-tree-sennode-name').click(function(){
//        var $a = $(this);
//        frmDeviceMgmt_log.debug('click sensnode from IoTGW');
//        var agentId = $a.html().trim();
//        frmDeviceMgmt_log.debug('SenNode: ' + agentId);
//        frmDeviceMgmt_DeviceBasicEdit(agentId);
//        
//    });
//}

//added by ken 2015/02/17
/**
 * Call by frmDeviceMgmt_buildDeviceInfoSpecTreegird
 *
 **/
function frmDeviceMgmt_appendSensorNodeTreegirdElem(pathId, treegridId, treegridPId, displayNodeName, pathIdWithoutN, nodeValue) {
    /*
     *Mock
     <table class="tree">
     <tr class="treegrid-1">
     <td>Root node</td><td>Additional info</td>
     </tr>
     <tr class="treegrid-2 treegrid-parent-1">
     <td>Node 1-1</td><td>Additional info</td>
     </tr>
     <tr class="treegrid-3 treegrid-parent-1">
     <td>Node 1-2</td><td>Additional info</td>
     </tr>
     <tr class="treegrid-4 treegrid-parent-3">
     <td>Node 1-2-1</td><td>Additional info</td>
     </tr>
     </table>	  
     */

    frmDeviceMgmt_log.info('call frmDeviceMgmt_appendSensorNodeTreegirdElem func: ' + treegridPId);
    var sensorElems;
    var kindType;
    frmDeviceMgmt_log.info('treegridPId:' + treegridPId);
    if ((treegridPId == null) || (treegridPId < 0)) {
        frmDeviceMgmt_log.info('add treegrid Parent');
        sensorElems += '<tr data-senser-path-id="' + pathId + '" class="treegrid-' + treegridId + ' treegridparent" >';
        kindType = 'Sensor Node';

        sensorElems += '<td>';
        sensorElems += '<a class="treegrid-parent-name action-a ui-link">';
    } else {
        frmDeviceMgmt_log.info('add treegrid Child');
        sensorElems += '<tr data-sensor-path-sid="' + pathId + '" class=" treegrid-' + treegridId + ' treegrid-parent-' + treegridPId + '">';
        kindType = 'Sensor';
        //sub-node icon
        sensorElems += '<td class="device-tree-node-start">';
        sensorElems += '<a class="device-tree-node-name treegrid-child-name action-a ui-link">';
    }

    //sensor name

    sensorElems += displayNodeName;
    sensorElems += '</td>';

    //kind
    sensorElems += '<td>';
    sensorElems += kindType;
    sensorElems += '</td>';

    //id path
    sensorElems += '<td>';
    sensorElems += pathIdWithoutN;
    sensorElems += '</td>';

    sensorElems += '<td>';
    sensorElems += nodeValue;
    sensorElems += '</td>';

    sensorElems += '</tr>';
    return sensorElems;
}

/*
 * SensorInfo/Agent report Dialogs
 * 
 */

//added by ken 2015/02/17    
function frmDeviceMgmt_OpenIoTGwSensorInfo(senNodeData) {
    frmDeviceMgmt_log.info('call frmDeviceMgmt_OpenIoTGwSensorInfo func');
    //    frmDeviceMgmt_log.debug(sensorData);
    if (typeof (frmDevsenNodeDataiceMgmtIoTGwSensorInfo_m_Request) == 'undefined')
    {
        frmDeviceMgmt_log.debug('first open');

        $('#index_pnlDeviceMgmtIoTGwSensorInfo').load('page_module/DeviceMgmt/frmDeviceMgmtIoTGwSensorInfo.html?d=' + escape(Date()), function () {
            $('#index_pnlDeviceMgmtIoTGwSensorInfo').trigger('create');
            $global.faddingShow(true);

            //show dialog div
            $('#index_pnlDeviceMgmtIoTGwSensorInfo').show();
            //畫圖要等放新載入的頁面出來再執行，不然會出不出東西
            frmDeviceMgmtIoTGwSensorInfo_initialize(false, $(senNodeData).find('agentId').text(), $(senNodeData).find('name').text());
        });
    }
    else
    {
        frmDeviceMgmt_log.debug('re-open');
        $global.faddingShow(true);

        //show dialog div     
        $('#index_pnlDeviceMgmtIoTGwSensorInfo').show();
        //畫圖要等放新載入的頁面出來再執行，不然會出不出東西
        frmDeviceMgmtIoTGwSensorInfo_initialize(true, $(senNodeData).find('agentId').text(), $(senNodeData).find('name').text());
    }
}
//added by ken 2015/03/17
function frmDeviceMgmt_OpenAgentReport(agentID, agentName, agentType, reportStatus, $currStatus) {
    frmDeviceMgmt_log.info('call frmDeviceMgmt_OpenAgentReport func');

    if (typeof (frmDeviceMgmtAgentReport_initialize) == 'undefined')
    {
        frmDeviceMgmt_log.info('show agent report info (A)');
        $('#index_pnlDeviceMgmtAgentReport').load('page_module/DeviceMgmt/frmDeviceMgmtAgentReport.html?d=' + escape(Date()), function () {
            frmDeviceMgmt_log.info('show agent report info callback (A)');
            $('#index_pnlDeviceMgmtAgentReport').trigger('create');

            //set ui
            $("#frmDeviceMgmtAgentReport_Target").html(agentName);
            $("#frmDeviceMgmtAgentReport_Target").data('agent', {
                id: agentID,
                name: agentName,
                type: agentType,
                reportStatus: reportStatus
            });
            $("#frmDeviceMgmtAgentReport_Target").data('jqStatus', $currStatus);

            $global.faddingShow(true);
            frmDeviceMgmtAgentReport_initialize(function () {
                frmDeviceMgmt_log.info('show agent report info callback (B)');
            });
        });
    }
    else
    {
        frmDeviceMgmt_log.info('show hw info (B)');

        //set ui
        $("#frmDeviceMgmtAgentReport_Target").html(agentName);
        $("#frmDeviceMgmtAgentReport_Target").data('agent', {
            id: agentID,
            name: agentName,
            type: agentType,
            reportStatus: reportStatus
        });
        $("#frmDeviceMgmtAgentReport_Target").data('jqStatus', $currStatus);

        $global.faddingShow(true);
        frmDeviceMgmtAgentReport_initialize(function () {

        });
    }
}

/*
 *  Column visiable controll
 */
//added by ken 2014/03/11
function frmDeviceMgmt_resetTableColumnOnIE8(callback) {
    frmDeviceMgmt_log.info('call frmDeviceMgmt_resetTableColumnOnIE8 func');
    return ;
    
    if (typeof (IE) != 'undefined') {
        var $frmDeviceMgmt_DeviceHeader = $('#frmDeviceMgmt_DeviceHeader');
        var $frmDeviceMgmt_DeviceBody = $('#frmDeviceMgmt_DeviceBody');

        $frmDeviceMgmt_DeviceHeader.css('display', 'inline-table');
        $frmDeviceMgmt_DeviceBody.css('display', 'inline-table');


        var resetTableTimer =
                window.setTimeout(function () {
                    frmDeviceMgmt_log.debug('reset table display attritube');

                    clearTimeout(resetTableTimer);
                    frmDeviceMgmt_log.debug('kill table dispaly timer: ' + resetTableTimer);

                    $frmDeviceMgmt_DeviceHeader.css('display', '');
                    $frmDeviceMgmt_DeviceBody.css('display', '');

                }, 0);
        frmDeviceMgmt_log.debug('table dispaly timer: ' + resetTableTimer);
    }


}
//added by ken 2015/04/23
function frmDeviceMgmt_ResetColumnVisableMenu() {
    frmDeviceMgmt_log.info('call frmDeviceMgmt_ResetColumnVisableMenu func');
    $('#frmDeviceMgmt_DeviceHeader').find('th').show();
    $('#frmDeviceMgmt_ColumnVisibleMenu span.ui-icon').removeClass('ui-icon-delete').addClass('ui-icon-check');
}
//added by ken 2015/05/15
function frmDeviceMgmt_setVisableColunmOfTable() {
    frmDeviceMgmt_log.info('call frmDeviceMgmt_setVisableColunmOfTable func');

    var $frmDeviceMgmt_ColumnVisibleMenu = $('#frmDeviceMgmt_ColumnVisibleMenu');
    var columnVisableConfig = store.get('columnVisable');
    frmDeviceMgmt_log.debug(columnVisableConfig);
    if (typeof (columnVisableConfig) != 'undefined') {
        for (columnKey in columnVisableConfig) {
            frmDeviceMgmt_log.debug('columnKey: ' + columnKey + ', visable: ' + columnVisableConfig[columnKey]);
            //set curret column status
            var $currVisbleItem = frmDeviceMgmt_getColumnVisableOfMenu(columnKey);
            frmDeviceMgmt_setColumnVisableOfMenu($currVisbleItem, columnVisableConfig[columnKey]);
        }
    }
}
//added by ken 2015/05/18
function frmDeviceMgmt_getColumnVisableOfMenu(columnName) {
    frmDeviceMgmt_log.info('call frmDeviceMgmt_getColumnVisableOfMenu func: ' + columnName);
    var $frmDeviceMgmt_ColumnVisibleMenu = $('#frmDeviceMgmt_ColumnVisibleMenu ul');
    var $currVisbleItem = $frmDeviceMgmt_ColumnVisibleMenu.find('li a[data-column="' + columnName + '"]');
    if ($currVisbleItem.length < 0) {
        frmDeviceMgmt_log.error('cannot get column type: ' + columnName);
    }
    return $currVisbleItem;
}
//added by ken 2015/05/18
function frmDeviceMgmt_setColumnVisableOfMenu($currVisbleItem, visibleOrNot) {

    frmDeviceMgmt_log.info('call frmDeviceMgmt_setColumnVisableOfMenu func');

    var oldIcon = $currVisbleItem.attr('data-icon');
    var columnName = $currVisbleItem.attr('data-column');

    frmDeviceMgmt_log.debug('change column (' + columnName + ') visibleOrNot: ' + visibleOrNot);

    //added by ken 2015/5/18
    frmDeviceMgmt_setColumnVisableOfTable(columnName, visibleOrNot);

    //added by ken 2015/5/15
    //in order to keep show/hide column status
    frmDeviceMgmt_setColumnVisableMenuConfig(columnName, visibleOrNot);

    //update icon
    frmDeviceMgmt_log.debug('visibleOrNot: ' + visibleOrNot);
    if (!visibleOrNot) {
        //uncheck =>  hide column
        newIcon = 'delete';

    } else {
        //check => show column
        newIcon = 'check';
    }
    frmDeviceMgmt_log.debug('oldIcon: ' + oldIcon);
    frmDeviceMgmt_log.debug('newIcon: ' + newIcon);
    $currVisbleItem.attr('data-icon', newIcon)
            .find('.ui-icon')
            .removeClass('ui-icon-' + oldIcon)
            .addClass('ui-icon-' + newIcon);


    frmDeviceMgmt_setColumnVisableOfTable(columnName, visibleOrNot);
    frmDeviceMgmt_setColumnVisableMenuConfig(columnName, visibleOrNot);
}
function frmDeviceMgmt_setColumnVisableOfTable(columnName, visibleOrNot) {
    frmDeviceMgmt_log.info('call frmDeviceMgmt_setColumnVisableOfTable func: ' + columnName + ', ' + visibleOrNot);

    var $frmDeviceMgmt_DeviceHeader = $('#frmDeviceMgmt_DeviceHeader');
    var $frmDeviceMgmt_DeviceBody = $('#frmDeviceMgmt_DeviceBody');
    //get column elem 
    var $targetTHOnHeader = $frmDeviceMgmt_DeviceHeader.find('tr th[colval=' + columnName + ']');


    //get column index
    var indexOfTargetTHOnHeader = $targetTHOnHeader.index();

    frmDeviceMgmt_log.debug('column index of target: ' + indexOfTargetTHOnHeader);
    if (indexOfTargetTHOnHeader < 0) {
        frmDeviceMgmt_log.error('can not find column index of target');
    } else {

        //create selector cmd
        //!!impartant: index need to add 1
        var visibleSelector = 'td:nth-child(' + (indexOfTargetTHOnHeader + 1) + ')';

        if (visibleOrNot) {

            $targetTHOnHeader.show();
            $frmDeviceMgmt_DeviceBody.find(visibleSelector).show();

        } else {

            $targetTHOnHeader.hide();
            $frmDeviceMgmt_DeviceBody.find(visibleSelector).hide();
        }

        frmDeviceMgmt_resetTableColumnOnIE8();

    }
}
//added by ken 2015/05/15
function frmDeviceMgmt_setColumnVisableMenuConfig(columnName, visibleOrNot) {

    frmDeviceMgmt_log.info('call frmDeviceMgmt_setColumnVisableMenuConfig func: ' + columnName + ', ' + visibleOrNot);
    var columnVisableConfig = store.get('columnVisable');
    if (typeof (columnVisableConfig) != 'undefined') {
        columnVisableConfig = store.get('columnVisable');
    } else {
        columnVisableConfig = {};
    }
    columnVisableConfig[columnName] = visibleOrNot;
    store.set('columnVisable', columnVisableConfig);
}

function frmDeviceMgmt_MapItemInfoMenu(strID, strName, strDeviceIcon , strAgentType)
{
    $('#index_MapPopupInfo').attr("ItemType", strAgentType);
    $('#index_MapPopupInfo').attr("ItemValue", strID);
    $('#index_MapPopupInfo').attr("ItemName", strName);
    $('#index_MapPopupInfo').attr("ItemIcon", strDeviceIcon);
    
    switch(strAgentType)
    {
        case 'IPC':
        case 'IPC_IoTGW':
            $('#index_lstMapPopupInfo li[ItemValue="SWInfo"]').show();
            break;
        case 'SenHub':
            $('#index_lstMapPopupInfo li[ItemValue="SWInfo"]').hide();
            break;
    };
    frmDeviceMgmt_m_SelectAgentID = strID;
    $('#index_MapPopupInfo').show();
    $('#index_MapPopupInfo').popup("open");
    frmInfoWindow_m_autoHide = false;
    
}

function frmDeviceMgmt_issupportNoVNC() {
    var result = false;
    if (typeof WebSocket !== 'undefined') {
        /*supported websocket*/
        //if (window.applicationCache) 
        {
            /*supported html5*/
            if (document.createElement('canvas').getContext) {
                /*supported canvas*/
                result = true;
            }
        }
    }
    if(result){
        if(msieversion()){ 
            result = false;
        }        
        if(firefoxversion()){ 
            result = false;
        }        
    }
    return result;
}

function msieversion() {
    var result = true;
    var ua = window.navigator.userAgent;
    var msie = ua.indexOf("MSIE ");

    if (msie > 0 || !!navigator.userAgent.match(/Trident.*rv\:11\./))  // If Internet Explorer, return version number
    {
        result = true;
//        alert(parseInt(ua.substring(msie + 5, ua.indexOf(".", msie))));
    }
    else  // If another browser, return 0
    {
        result = false;
//        alert('otherbrowser');
    }
    return result;
}

function firefoxversion() {
    var result = true;
    var ua = window.navigator.userAgent;
    if ((ua.toLowerCase().indexOf("firefox") >= 0) && (window.location.protocol === "https:"))                    
    {
        result = true;
    }
    else
    {
        result = false;
    }
    return result;
}